# coding: utf-8

# flake8: noqa

"""
    sevdesk API

    <b>Contact:</b> To contact our support click  <a href='https://landing.sevdesk.de/service-support-center-technik'>here</a><br><br>   # General information  Welcome to our API!<br>  sevdesk offers you  the possibility of retrieving data using an interface, namely the sevdesk API, and making  changes without having to use the web UI. The sevdesk interface is a REST-Full API. All sevdesk  data and functions that are used in the web UI can also be controlled through the API.   # Cross-Origin Resource Sharing  This API features Cross-Origin Resource Sharing (CORS).<br>  It enables cross-domain communication from the browser.<br>  All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.    # Embedding resources  When retrieving resources by using this API, you might encounter nested resources in the resources you requested.<br>  For example, an invoice always contains a contact, of which you can see the ID and the object name.<br>  This API gives you the possibility to embed these resources completely into the resources you originally requested.<br>  Taking our invoice example, this would mean, that you would not only see the ID and object name of a contact, but rather the complete contact resource.    To embed resources, all you need to do is to add the query parameter 'embed' to your GET request.<br>  As values, you can provide the name of the nested resource.<br>  Multiple nested resources are also possible by providing multiple names, separated by a comma.    # Authentication and Authorization  The sevdesk API uses a token authentication to authorize calls. For this purpose every sevdesk administrator has one API token, which is a <b>hexadecimal string</b>  containing <b>32 characters</b>. The following clip shows where you can find the  API token if this is your first time with our API.<br><br> <video src='openAPI/img/findingTheApiToken.mp4' controls width='640' height='360'> Your browser cannot play this video.<br> This video explains how to find your sevDesk API token. </video> <br> The token will be needed in every request that you want to send and needs to be provided as a value of an <b>Authorization Header</b>.<br> In this case, we used some random API token. The example shows the token in the Authorization Header. <ul> <li>\"Authorization\" :<span style='color:red'>\"b7794de0085f5cd00560f160f290af38\"</span></li> </ul> The api tokens have an infinite lifetime and, in other words, exist as long as the sevdesk user exists.<br> For this reason, the user should <b>NEVER</b> be deleted.<br> If really necessary, it is advisable to save the api token as we will <b>NOT</b> be able to retrieve it afterwards!<br> It is also possible to generate a new API token, for example, if you want to prevent the usage of your sevdesk account by other people who got your current API token.<br> To achieve this, you just need to click on the \"generate new\" symbol to the right of your token and confirm it with your password.  # API News  To never miss API news and updates again, subscribe to our <b>free API newsletter</b> and get all relevant  information to keep your sevdesk software running smoothly. To subscribe, simply click <a href = 'https://landing.sevdesk.de/api-newsletter'><b>here</b></a> and confirm the email address to which we may send all updates relevant to you.  # API Requests  In our case, REST API requests need to be build by combining the following components. <table> <tr> <th><b>Component</b></th> <th><b>Description</b></th> </tr> <tr> <td>HTTP-Methods</td> <td> <ul> <li>GET (retrieve a resource)</li> <li>POST (create a resource)</li> <li>PUT (update a resource)</li> <li>DELETE (delete a resource)</li> </ul> </td> </tr> <tr> <td>URL of the API</td> <td><span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span></td> </tr> <tr> <td>URI of the resource</td> <td>The resource to query.<br>For example contacts in sevdesk:<br><br> <span style='color:red'>/Contact</span><br><br> Which will result in the following complete URL:<br><br> <span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span><span style='color:red'>/Contact</span> </td> </tr> <tr> <td>Query parameters</td> <td>Are attached by using the connectives <b>?</b> and <b>&</b> in the URL.<br></td> </tr> <tr> <td>Request headers</td> <td>Typical request headers are for example:<br> <div> <br> <ul> <li>Content-type</li> <li>Authorization</li> <li>Accept-Encoding</li> <li>User-Agent</li> <li>X-Version: Used for resource versioning see information below</li> <li>...</li> </ul> </div> </td> </tr> <tr>  <td>Response headers</td> <td> Typical response headers are for example:<br><br> <div> <ul>  <li>Deprecation: If a resource is deprecated we return true or a timestamp since when</li> <li>...</li> </ul> </div> </td> </tr> <tr> <td>Request body</td> <td>Mostly required in POST and PUT requests.<br> Often the request body contains json, in our case, it also accepts url-encoded data. </td> </tr> </table><br> <span style='color:red'>Note</span>: please pass a meaningful entry at the header \"User-Agent\".  If the \"User-Agent\" is set meaningfully, we can offer better support in case of queries from customers.<br> An example how such a \"User-Agent\" can look like: \"Integration-name by abc\". <br><br> This is a sample request for retrieving existing contacts in sevdesk using curl:<br><br> <img src='openAPI/img/GETRequest.PNG' alt='Get Request' height='150'><br><br> As you can see, the request contains all the components mentioned above.<br> It's HTTP method is GET, it has a correct endpoint  (<span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span><span style='color:red'>/Contact</span>), query parameters and additional <b>header</b> information!<br><br> <b>Query Parameters</b><br><br> As you might have seen in the sample request above, there are several query parameters located in the url.<br> Those are mostly optional but prove to be very useful for a lot of requests as they can limit, extend, sort or filter the data you will get as a response.<br><br> These are the most used query parameter for the sevdesk API. <table> <tr> <th><b>Parameter</b></th> <th><b>Description</b></th> </tr> <tr> <td>embed</td> <td>Will extend some of the returned data.<br> A brief example can be found below.</td> </tr> <tr> <td>countAll</td> <td>\"countAll=true\" returns the number of items</td> </tr> </table> This is an example for the usage of the embed parameter.<br> The following first request will return all company contact entries in sevdesk up to a limit of 100 without any additional information and no offset.<br><br> <img src='openAPI/img/ContactQueryWithoutEmbed.PNG' width='900' height='850'><br><br> Now have a look at the category attribute located in the response.<br> Naturally, it just contains the id and the object name of the object but no further information.<br> We will now use the parameter embed with the value \"category\".<br><br> <img src='openAPI/img/ContactQueryWithEmbed.PNG' width='900' height='850'><br><br> As you can see, the category object is now extended and shows all the attributes and their corresponding values.<br><br> There are lot of other query parameters that can be used to filter the returned data for objects that match a certain pattern, however, those will not be mentioned here and instead can be found at the detail documentation of the most used API endpoints like contact, invoice or voucher.<br><br> <b>Pagination</b><br> <table> <tr> <th><b>Parameter</b></th> <th><b>Description</b></th> </tr> <tr> <td>limit</td> <td>Limits the number of entries that are returned.<br> Most useful in GET requests which will most likely deliver big sets of data like country or currency lists.<br> In this case, you can bypass the default limitation on returned entries by providing a high number. </td> </tr> <tr> <td>offset</td> <td>Specifies a certain offset for the data that will be returned.<br> As an example, you can specify \"offset=2\" if you want all entries except for the first two.</td> </tr> </table> Example: <ul><li><code>ht<span>tps://my.sevdesk.de/api/v1/Invoice?offset=20&limit=10<span></code></li></ul> <b>Request Headers</b><br><br> The HTTP request (response) headers allow the client as well as the server to pass additional information with the request.<br> They transfer the parameters and arguments which are important for transmitting data over HTTP.<br> Three headers which are useful / necessary when using the sevdesk API are \"Authorization, \"Accept\" and  \"Content-type\".<br> Underneath is a brief description of why and how they should be used.<br><br> <b>Authorization</b><br><br> Should be used to provide your API token in the header. <ul> <li>Authorization:<span style='color:red'>yourApiToken</span></li> </ul> <b>Accept</b><br><br> Specifies the format of the response.<br> Required for operations with a response body. <ul> <li>Accept:application/<span style='color:red'>format</span> </li> </ul> In our case, <code><span style='color:red'>format</span></code> could be replaced with <code>json</code> or <code>xml</code><br><br> <b>Content-type</b><br><br> Specifies which format is used in the request.<br> Is required for operations with a request body. <ul> <li>Content-type:application/<span style='color:red'>format</span></li> </ul> In our case,<code><span style='color:red'>format</span></code>could be replaced with <code>json</code> or <code>x-www-form-urlencoded</code> <br><br><b>API Responses</b><br><br> HTTP status codes<br> When calling the sevdesk API it is very likely that you will get a HTTP status code in the response.<br> Some API calls will also return JSON response bodies which will contain information about the resource.<br> Each status code which is returned will either be a <b>success</b> code or an <b>error</b> code.<br><br> Success codes <table> <tr> <th><b>Status code</b></th> <th><b>Description</b></th> </tr> <tr> <td><code>200 OK</code></td> <td>The request was successful</td> </tr> <tr> <td><code>201 Created</code></td> <td>Most likely to be found in the response of a <b>POST</b> request.<br> This code indicates that the desired resource was successfully created.</td> </tr> </table> <br>Error codes <table> <tr> <th><b>Status code</b></th> <th><b>Description</b></th> </tr> <tr> <td><code>400 Bad request</code></td> <td>The request you sent is most likely syntactically incorrect.<br> You should check if the parameters in the request body or the url are correct.</td> </tr> <tr> <td><code>401 Unauthorized</code></td> <td>The authentication failed.<br> Most likely caused by a missing or wrong API token.</td> </tr> <tr> <td><code>403 Forbidden</code></td> <td>You do not have the permission the access the resource which is requested.</td> </tr> <tr> <td><code>404 Not found</code></td> <td>The resource you specified does not exist.</td> </tr> <tr> <td><code>500 Internal server error</code></td> <td>An internal server error has occurred.<br> Normally this means that something went wrong on our side.<br> However, sometimes this error will appear if we missed to catch an error which is normally a 400 status code! </td> </tr> </table> <br><br> <b>Resource Versioning</b> <br><br> We use resource versioning to handle breaking changes for our endpoints, these are rarely used and will be communicated before we remove older versions.<br> To call a different version we use a specific header <code>X-Version</code> that should be filled with the desired version.<br> <ul>  <li>If you do not specify any version we assume <code>default</code></li> <li>If you specify a version that does not exist or was removed, you will get an error with information which versions are available</li> </ul> <table> <tr> <th>X-Version</th> <th>Description</th> </tr> <tr> <td><code>default</code></td> <td>Should always reference the oldest version.<br> If a specific resource is updated with a new version, <br> then the default version stays the same until the old version is deleted</td> </tr> <tr> <td><code>1.0</code> ... <code>1.9</code></td> <td>Our incrementally version for each resource independent<br> <b>Important</b>: A resource can be available via <code>default</code> but not <code>1.0</code></td> </tr> </table>  # Your First Request  After reading the introduction to our API, you should now be able to make your first call.<br> For testing our API, we would always recommend to create a trial account for sevdesk to prevent unwanted changes to your main account.<br> A trial account will be in the highest tariff (materials management), so every sevdesk function can be tested!   To start testing we would recommend one of the following tools: <ul> <li><a href='https://www.getpostman.com/'>Postman</a></li> <li><a href='https://curl.haxx.se/download.html'>cURL</a></li> </ul> This example will illustrate your first request, which is creating a new Contact in sevdesk.<br> <ol> <li>Download <a href='https://www.getpostman.com/'><b>Postman</b></a> for your desired system and start the application</li> <li>Enter <span><b>ht</span>tps://my.sevdesk.de/api/v1/Contact</b> as the url</li> <li>Create an authorization header and insert your API token as the value</li> <li>For this test, select <b>POST</b> as the HTTP method</li> <li>Go to <b>Headers</b> and enter the key-value pair <b>Content-type</b> + <b>application/x-www-form-urlencoded</b><br> As an alternative, you can just go to <b>Body</b> and select <b>x-www-form-urlencoded</b></li> <li>Now go to <b>Body</b> (if you are not there yet) and enter the key-value pairs as shown in the following picture<br><br> <img src='openAPI/img/FirstRequestPostman.PNG' width='900'><br><br></li> <li>Click on <b>Send</b>. Your response should now look like this:<br><br> <img src='openAPI/img/FirstRequestResponse.PNG' width='900'></li> </ol> As you can see, a successful response in this case returns a JSON-formatted response body containing the contact you just created.<br> For keeping it simple, this was only a minimal example of creating a contact.<br> There are however numerous combinations of parameters that you can provide which add information to your contact.  # sevdesk-Update 2.0  Started in 2024 we introduced a new era of bookkeeping in sevdesk. You can check if you already received the update by clicking on your profile in the top right in the sevdesk WebApp or by using the [Tools/bookkeepingSystemVersion endpoint](#tag/Basics/operation/bookkeepingSystemVersion).<br> The old version will be available for some customers until the end of 2024. In this short list we have outlined the changed endpoints with links to jump to the descriptions. If you received the [api newsletter](https://landing.sevdesk.de/api-newsletter) you already know what changed. Otherwise you can check the api changes [here](https://tech.sevdesk.com/api_news/posts/2024_04_04-system-update-breaking-changes/).  ## Check your bookkeeping system version  With this endpoint you can check which version you / your client uses. On that basis you must use the old or new versions of the endpoints. [Tools/bookkeepingSystemVersion Endpoint](#tag/Basics/operation/bookkeepingSystemVersion)  ## Tax Rules  <I><b>(affects the properties taxType and taxSet)</b></I><br> With sevdesk-Update 2.0 we changed the available tax rules. Due to a high likeliness of non-compliant accounting, we won't support the following tax type with the sevdesk-Update 2.0 anymore:  `taxType = custom (this includes 'taxSet': ... )`  If you only use <code>taxType = default</code>, <code>taxType = eu</code> and / or <code>taxType = ss</code>, these tax types will automatically be mapped to the new tax rules for a transition period, but you have to make sure the taxRate used in positions is within the allowed ones (you may use the [ReceiptGuidance endpoint](#tag/Voucher/operation/forAllAccounts) for that), otherwise the API will return a validation error (HTTP status code 422). For [orders](#tag/Order), [invoices](#tag/Invoice), [vouchers](#tag/Voucher) and [credit notes](#tag/CreditNote) that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned.<br> So orders, invoices, vouchers and credit notes created within sevdesk system version 1.0 still have a taxType in the response. When they are created in sevdesk-Update 2.0 they will have a taxRule instead.<br> You can continue to use taxType at first, but we recommend switching to taxRule as there are new options available that were not previously supported.<br> For orders, invoices, vouchers and credit notes that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned. This documentation holds the most current version of the endpoints.<br> Here are lists of the currently available tax rules, sorted by their use case, structured into revenue/expense and 'Regelbesteuerer'/'Kleinunternehmer'.  #### VAT rules for 'Regelbesteuerung' in sevdesk-Update 2.0 (Revenue)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> <th>Unsupported use cases</th> </tr> <tr> <td>Umsatzsteuerpflichtige Umsätze</td> <td><code>'taxRule': 1</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'default'</code></td> <td>-</td> </tr> <tr> <td>Ausfuhren</td> <td><code>'taxRule': 2</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Innergemeinschaftliche Lieferungen</td> <td><code>'taxRule': 3</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'eu'</code></td> <td>-</td> </tr> <tr> <td>Steuerfreie Umsätze §4 UStG</td> <td><code>'taxRule': 4</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b UStG</td> <td><code>'taxRule': 5</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Nicht im Inland steuerbare Leistung</td> <td><code>'taxRule': 17</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'noteu'</code></td> <td> <ul> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (goods)</td> <td><code>'taxRule': 18</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (electronic service)</td> <td><code>'taxRule': 19</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (other service)</td> <td><code>'taxRule': 20</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> </table>   See the <a href=\"#tag/Invoice/operation/createInvoiceFromOrder\">example request</a> to create a normal invoice <code>\"invoiceType\": \"RE\"</code> from an order that uses a tax rule that does not support advance, partial or final invoices.    #### VAT rules for 'Regelbesteuerung' in sevdesk-Update 2.0 (Expense)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Innergemeinschaftliche Erwerbe</td> <td><code>'taxRule': 8</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 9</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'default'</code></td> </tr> <tr> <td>Nicht vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 10</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b Abs. 2 UStG mit Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 12</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 13</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b Abs. 1 EU Umsätze 0% (19%)</td> <td><code>'taxRule': 14</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> </table>    #### VAT rules for small business owner ('Kleinunternehmer') in sevdesk-Update 2.0 (Revenue)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Steuer nicht erhoben nach §19UStG</td> <td><code>'taxRule': 11</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'ss'</code></td> </tr> </table>    #### VAT rules for small business owner ('Kleinunternehmer') in sevdesk-Update 2.0 (Expense)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Nicht vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 10</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'ss'</code></td> </tr> <tr> <td>Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 13</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> </table>    ## Booking Accounts  <I><b>(affects the property accountingType)</b></I><br> With sevdesk-Update 2.0 we changed the available booking accounts and their combinatorics. If you use accountingTypes with SKR numbers that are still available in our receipt guidance, you do not have to change anything in your requests. These booking accounts will automatically be mapped to the new representation (Account Datev). But you have to make sure the taxRate used in positions and taxRule used in the voucher is within the allowed ones (check the [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)) of the provided booking account, otherwise the API will return a validation error (HTTP status code 422). For orders, invoices, vouchers and credit notes in that were created within sevdesk-Update 2.0 the response will change in all endpoints were these objects are returned.  ## Receipt Guidance  To help you decide which account can be used in conjunction with which tax rules, tax rates and documents, we created several guidance endpoints just there for you to get helpful information. You can find the descriptions in the changes section for Vouchers below or jump directly to the endpoint description by using this link: [Receipt Guidance](#tag/Voucher/operation/forAllAccounts).<br> Receipt Guidance is planned to give you guidance in which account you can pick (depending on your filter criteria and the client settings (e.g. 'Kleinunternehmer')) and which tax rate and [tax rules](#section/sevdesk-Update-2.0/Tax-Rules) are comptaible with them.   ## Vouchers   ### Saving a new voucher ([Voucher/Factory/saveVoucher](#tag/Voucher/operation/voucherFactorySaveVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Custom vat regulations (taxType = custom and provided taxSet)</li> <li>Only specific tax rates and booking accounts are available. Check [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)</li> <li>Custom accounting types do not work anymore</li> <li>Using an asset booking account without creating an asset is no longer possible</li> <li>A voucher can not be directly set to paid anymore, therefore only status <code>DRAFT (50)</code> or <code>UNPAID / DUE (100)</code> are possible when creating a new voucher. Use the [/api/v1/Voucher/{voucherId}/bookAmount endpoint](#tag/Voucher/operation/bookVoucher) to set a voucher to paid</li> <li>Setting or changing the property enshrined. Use our new endpoint [/api/v1/Voucher/{voucherId}/enshrine](#tag/Voucher/operation/voucherEnshrine) to enshrine a voucher</li> </ol>  ### Get or update an existing voucher ([Voucher/{voucherId}](#tag/Voucher/operation/updateVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Custom vat regulations (taxType = custom and provided taxSet)</li> <li>See [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts) to check which tax rates are available in conjunction with which tax rules</li> </ol>  ### Book a voucher ([Voucher/{voucherId}](#tag/Voucher/operation/bookVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Voucher with negative voucher positions can not use 'cash discount' as a payment difference anymore</li> <li>A Voucher can only be booked when it was registered beforehand (see above)</li> <li>Based on the combination of voucher positions some payment difference reasons are not possible anymore</li> <li>The currency fluctuation (CF) type is no longer supported as a payment difference reason</li> </ol>  ## Banking  Following use cases do not work anymore or have changed: <ol> <li>Setting or changing the property enshrined will now only be available by using the [appropriate enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)</li> </ol>  ## Invoicing  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct invoices are created which than can be further processed in sevdesk. Following use cases do not work anymore or have changed: <ol> <li>Creating an invoice with taxType <code>custom</code> does not work anymore</li> <li>Processing an invoice beyond status <code>DRAFT (100)</code> without a contact does not work anymore</li> <li>Advanced invoices (<code>invoiceType: 'AR'</code>) and partial invoices (<code>invoiceType: 'TR'</code>) can only be created with the tax rule 'Umsatzsteuerpflichtige Umsätze (taxRule: 1)'(for Regelbesteuerer) or 'Steuer nicht erhoben nach §19 UStG (taxRule: 11)'(for Kleinunternehmer)</li> <li>Creating a dunning (<code>invoiceType: 'MA'</code>) with the value of property <code>reminderCharge</code> greater than 0 does not work anymore</li> <li>Creating an advanced invoice (<code>invoiceType: 'AR'</code>), a partial invoice (<code>invoiceType: 'TR'</code>) or a final invoice (<code>invoiceType: 'ER'</code>) with a currency deviating from the clients <code>defaultCurrency</code> is not possible anymore</li> <li>Changing the status manually does not work anymore (see 'Removed endpoint /Invoice/{invoiceId}/changeStatus' below)</li> <li>Enshrining now has to be done by using the [enshrine endpoint](#tag/Invoice/operation/invoiceEnshrine) (see below)</li> </ol>  ### Saving an invoice ([Invoice/Factory/saveInvoice](#tag/Invoice/operation/createInvoiceByFactory))  Following use cases do not work anymore or have changed: <ol> <li>Invoices can only be created with the status <code>DRAFT (100)</code> and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)) to automatically change the status accordingly</li> <li>Setting or changing the property <code>enshrined</code> is now only possible by using the [enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)</li> </ol>  ### Using an order to create an invoice ([Invoice/Factory/createInvoiceFromOrder](#tag/Invoice/operation/createInvoiceFromOrder))  Following use cases do not work anymore or have changed: <ol> <li>Creating a final invoice (partialType: 'ER') is not possible if an advanced invoice (partialType: 'AR') or partial invoice (partialType: 'TR') exists. This functionality will be added in a later update</li> </ol>  ### Removed endpoint /Invoice/{invoiceId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: <ul> <li>[Invoice/{invoiceId}/sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)</li> <li>[Invoice/{invoiceId}/sendBy](#tag/Invoice/operation/invoiceSendBy)</li> <li>[Invoice/{invoiceId}/bookAmount](#tag/Invoice/operation/bookInvoice)</li> <li>[Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)</li> <li>[Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)</li> </ul>  ### New endpoint [Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)  This new endpoint can be used to reset the status of an invoice to <code>DRAFT (100)</code>.  ### New endpoint [Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)  This new endpoint can be used to reset the status of an invoice to <code>OPEN (200)</code>.  ### New endpoint [Invoice/{invoiceId}/enshrine]((#tag/Invoice/operation/invoiceEnshrine))  The enshrine endpoint is now used to set the property <code>enshrined</code>. <b>This operation CAN NOT be undone due to legal reasons!</b>  ## Credit Notes  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct credit notes are created which than can be further processed in sevdesk. Due to the move from taxTypes/taxSets to taxRules you need to check the compatibility of the taxRules in combination with the tax rates. Following use cases do not work anymore or have changed: <ol> <li>Creating a credit note without a date of delivery (<code>deliveryDateUntil</code>) for an invoice that has a date of delivery (<code>deliveryDateUntil</code>) is no longer possible</li> <li>Creating a credit note with a date of delivery (<code>deliveryDateUntil</code>) for an invoice that has no date of delivery (<code>deliveryDateUntil</code>) is no longer possible</li> <li>Creating a credit note with a date of delivery (<code>deliveryDateUntil</code>) that is before the date of delivery (<code>deliveryDateUntil</code>) of the invoice is no longer possible</li> <li>Creating a credit note for an advanced invoice (<code>invoiceType: 'AR'</code>) or partial invoice (<code>invoiceType: 'TR'</code>) is no longer possible</li> <li>Creating a credit note for a voucher is no longer possible</li> <li>Creating a credit note with a <code>bookingCategory</code> other than <code>UNDERACHIEVEMENT</code> is no longer possible</li> <li>Currency fluctuation (CF) is no longer supported as a payment difference</li> </ol>  ### Saving a credit note ([CreditNote/Factory/saveCreditNote](#tag/CreditNote/operation/createcreditNote))  Following use cases do not work anymore or have changed: <ol> <li>Credit notes can only be created with the status <code>DRAFT (100)</code> and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)) to automatically change the status accordingly</li> <li>Enshrining now has to be done by using the enshrine endpoint (see below)</li> </ol>  ### Removed endpoint /CreditNote/Factory/createFromVoucher  The endpoint will be removed. It is not possible anymore to create credit notes for vouchers within sevdesk-Update 2.0. The endpoint continues to stay available for existing sevdesk system version 1.0 clients.  ### Removed endpoint /CreditNote/{creditNoteId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: <ul> <li>[CreditNote/{creditNoteId}/sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)</li> <li>[CreditNote/{creditNoteId}/sendBy](#tag/CreditNote/operation/creditNoteSendBy)</li> <li>[CreditNote/{creditNoteId}/bookAmount](#tag/CreditNote/operation/bookCreditNote)</li> <li>[CreditNote/{creditNoteId}/resetToDraft](#tag/CreditNote/operation/creditNoteResetToDraft)</li> <li>[CreditNote/{creditNoteId}/resetToOpen](#tag/CreditNote/operation/creditNoteResetToOpen)</li> </ul>  ### New endpoint CreditNote/{creditNoteId}/resetToDraft  This new endpoint can be used to reset the status of a credit note to <code>DRAFT (100)</code>. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToDraft).  ### New endpoint CreditNote/{creditNoteId}/resetToOpen  This new endpoint can be used to reset the status of a credit note to <code>OPEN (200)</code>. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToOpen).  ### New endpoint CreditNote/{creditNoteId}/enshrine  [The enshrine endpoint](#tag/CreditNote/operation/creditNoteEnshrine) is now used to set the property <code>enshrined</code>. <b>This operation CAN NOT be undone due to legal reasons!</b> ## Parts   ### General stricter validation in PUT and POST endpoints  Following use cases do not work anymore or have changed: <ol> <li>Creating products with a tax rate other than 0.0, 7.0 and 19.0 is no longer possible</li> </ol> 

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


__version__ = "0.1.0"

# import apis into sdk package
from pysevdesk.api.accounting_contact_api import AccountingContactApi
from pysevdesk.api.basics_api import BasicsApi
from pysevdesk.api.check_account_api import CheckAccountApi
from pysevdesk.api.check_account_transaction_api import CheckAccountTransactionApi
from pysevdesk.api.communication_way_api import CommunicationWayApi
from pysevdesk.api.contact_api import ContactApi
from pysevdesk.api.contact_address_api import ContactAddressApi
from pysevdesk.api.contact_field_api import ContactFieldApi
from pysevdesk.api.credit_note_api import CreditNoteApi
from pysevdesk.api.credit_note_pos_api import CreditNotePosApi
from pysevdesk.api.export_api import ExportApi
from pysevdesk.api.invoice_api import InvoiceApi
from pysevdesk.api.invoice_pos_api import InvoicePosApi
from pysevdesk.api.layout_api import LayoutApi
from pysevdesk.api.order_api import OrderApi
from pysevdesk.api.order_pos_api import OrderPosApi
from pysevdesk.api.part_api import PartApi
from pysevdesk.api.report_api import ReportApi
from pysevdesk.api.tag_api import TagApi
from pysevdesk.api.voucher_api import VoucherApi
from pysevdesk.api.voucher_pos_api import VoucherPosApi

# import ApiClient
from pysevdesk.api_response import ApiResponse
from pysevdesk.api_client import ApiClient
from pysevdesk.configuration import Configuration
from pysevdesk.exceptions import OpenApiException
from pysevdesk.exceptions import ApiTypeError
from pysevdesk.exceptions import ApiValueError
from pysevdesk.exceptions import ApiKeyError
from pysevdesk.exceptions import ApiAttributeError
from pysevdesk.exceptions import ApiException

# import models into sdk package
from pysevdesk.models.book_credit_note200_response import BookCreditNote200Response
from pysevdesk.models.book_credit_note200_response_credit_note import BookCreditNote200ResponseCreditNote
from pysevdesk.models.book_credit_note200_response_sev_client import BookCreditNote200ResponseSevClient
from pysevdesk.models.book_credit_note_request import BookCreditNoteRequest
from pysevdesk.models.book_credit_note_request_check_account import BookCreditNoteRequestCheckAccount
from pysevdesk.models.book_credit_note_request_check_account_transaction import BookCreditNoteRequestCheckAccountTransaction
from pysevdesk.models.book_invoice200_response import BookInvoice200Response
from pysevdesk.models.book_invoice200_response_credit_note import BookInvoice200ResponseCreditNote
from pysevdesk.models.book_invoice200_response_sev_client import BookInvoice200ResponseSevClient
from pysevdesk.models.book_invoice_request import BookInvoiceRequest
from pysevdesk.models.book_invoice_request_check_account_transaction import BookInvoiceRequestCheckAccountTransaction
from pysevdesk.models.book_voucher200_response import BookVoucher200Response
from pysevdesk.models.book_voucher200_response_credit_note import BookVoucher200ResponseCreditNote
from pysevdesk.models.book_voucher_request import BookVoucherRequest
from pysevdesk.models.book_voucher_request_check_account_transaction import BookVoucherRequestCheckAccountTransaction
from pysevdesk.models.bookkeeping_system_version200_response import BookkeepingSystemVersion200Response
from pysevdesk.models.bookkeeping_system_version200_response_objects import BookkeepingSystemVersion200ResponseObjects
from pysevdesk.models.check_account_transaction_enshrine200_response import CheckAccountTransactionEnshrine200Response
from pysevdesk.models.contact_customer_number_availability_check200_response import ContactCustomerNumberAvailabilityCheck200Response
from pysevdesk.models.create_clearing_account import CreateClearingAccount
from pysevdesk.models.create_clearing_account201_response import CreateClearingAccount201Response
from pysevdesk.models.create_clearing_account_response import CreateClearingAccountResponse
from pysevdesk.models.create_credit_note_from_invoice201_response import CreateCreditNoteFromInvoice201Response
from pysevdesk.models.create_credit_note_from_invoice201_response_objects import CreateCreditNoteFromInvoice201ResponseObjects
from pysevdesk.models.create_credit_note_from_invoice_request import CreateCreditNoteFromInvoiceRequest
from pysevdesk.models.create_credit_note_from_invoice_request_invoice import CreateCreditNoteFromInvoiceRequestInvoice
from pysevdesk.models.create_credit_note_from_voucher_request import CreateCreditNoteFromVoucherRequest
from pysevdesk.models.create_credit_note_from_voucher_request_voucher import CreateCreditNoteFromVoucherRequestVoucher
from pysevdesk.models.create_file_import_account import CreateFileImportAccount
from pysevdesk.models.create_file_import_account201_response import CreateFileImportAccount201Response
from pysevdesk.models.create_file_import_account_response import CreateFileImportAccountResponse
from pysevdesk.models.create_file_import_account_response_sev_client import CreateFileImportAccountResponseSevClient
from pysevdesk.models.create_invoice_reminder_request import CreateInvoiceReminderRequest
from pysevdesk.models.create_invoice_reminder_request_invoice import CreateInvoiceReminderRequestInvoice
from pysevdesk.models.create_tag_request import CreateTagRequest
from pysevdesk.models.create_tag_request_object import CreateTagRequestObject
from pysevdesk.models.credit_note_get_pdf200_response import CreditNoteGetPdf200Response
from pysevdesk.models.credit_note_reset_to_draft200_response import CreditNoteResetToDraft200Response
from pysevdesk.models.credit_note_reset_to_draft200_response_objects import CreditNoteResetToDraft200ResponseObjects
from pysevdesk.models.credit_note_reset_to_open200_response import CreditNoteResetToOpen200Response
from pysevdesk.models.credit_note_reset_to_open200_response_objects import CreditNoteResetToOpen200ResponseObjects
from pysevdesk.models.credit_note_send_by_request import CreditNoteSendByRequest
from pysevdesk.models.delete_check_account200_response import DeleteCheckAccount200Response
from pysevdesk.models.export_contact200_response import ExportContact200Response
from pysevdesk.models.export_contact200_response_objects import ExportContact200ResponseObjects
from pysevdesk.models.export_contact_sev_query_parameter import ExportContactSevQueryParameter
from pysevdesk.models.export_contact_sev_query_parameter_filter import ExportContactSevQueryParameterFilter
from pysevdesk.models.export_contact_sev_query_parameter_filter_country import ExportContactSevQueryParameterFilterCountry
from pysevdesk.models.export_credit_note200_response import ExportCreditNote200Response
from pysevdesk.models.export_credit_note200_response_objects import ExportCreditNote200ResponseObjects
from pysevdesk.models.export_credit_note_sev_query_parameter import ExportCreditNoteSevQueryParameter
from pysevdesk.models.export_credit_note_sev_query_parameter_filter import ExportCreditNoteSevQueryParameterFilter
from pysevdesk.models.export_credit_note_sev_query_parameter_filter_contact import ExportCreditNoteSevQueryParameterFilterContact
from pysevdesk.models.export_invoice200_response import ExportInvoice200Response
from pysevdesk.models.export_invoice200_response_objects import ExportInvoice200ResponseObjects
from pysevdesk.models.export_invoice_sev_query_parameter import ExportInvoiceSevQueryParameter
from pysevdesk.models.export_invoice_sev_query_parameter_filter import ExportInvoiceSevQueryParameterFilter
from pysevdesk.models.export_invoice_sev_query_parameter_filter_contact import ExportInvoiceSevQueryParameterFilterContact
from pysevdesk.models.export_invoice_zip200_response import ExportInvoiceZip200Response
from pysevdesk.models.export_invoice_zip200_response_objects import ExportInvoiceZip200ResponseObjects
from pysevdesk.models.export_invoice_zip_sev_query_parameter import ExportInvoiceZipSevQueryParameter
from pysevdesk.models.export_transactions200_response import ExportTransactions200Response
from pysevdesk.models.export_transactions200_response_objects import ExportTransactions200ResponseObjects
from pysevdesk.models.export_transactions_sev_query_parameter import ExportTransactionsSevQueryParameter
from pysevdesk.models.export_transactions_sev_query_parameter_filter import ExportTransactionsSevQueryParameterFilter
from pysevdesk.models.export_transactions_sev_query_parameter_filter_check_account import ExportTransactionsSevQueryParameterFilterCheckAccount
from pysevdesk.models.export_voucher200_response import ExportVoucher200Response
from pysevdesk.models.export_voucher_sev_query_parameter import ExportVoucherSevQueryParameter
from pysevdesk.models.export_voucher_sev_query_parameter_filter import ExportVoucherSevQueryParameterFilter
from pysevdesk.models.export_voucher_sev_query_parameter_filter_contact import ExportVoucherSevQueryParameterFilterContact
from pysevdesk.models.export_voucher_zip200_response import ExportVoucherZip200Response
from pysevdesk.models.export_voucher_zip200_response_objects import ExportVoucherZip200ResponseObjects
from pysevdesk.models.export_voucher_zip_sev_query_parameter import ExportVoucherZipSevQueryParameter
from pysevdesk.models.export_voucher_zip_sev_query_parameter_filter import ExportVoucherZipSevQueryParameterFilter
from pysevdesk.models.export_voucher_zip_sev_query_parameter_filter_contact import ExportVoucherZipSevQueryParameterFilterContact
from pysevdesk.models.find_contacts_by_custom_field_value200_response import FindContactsByCustomFieldValue200Response
from pysevdesk.models.for_all_accounts200_response import ForAllAccounts200Response
from pysevdesk.models.get_accounting_contact200_response import GetAccountingContact200Response
from pysevdesk.models.get_balance_at_date200_response import GetBalanceAtDate200Response
from pysevdesk.models.get_check_accounts200_response import GetCheckAccounts200Response
from pysevdesk.models.get_communication_way_keys200_response import GetCommunicationWayKeys200Response
from pysevdesk.models.get_communication_way_keys200_response_objects_inner import GetCommunicationWayKeys200ResponseObjectsInner
from pysevdesk.models.get_communication_ways200_response import GetCommunicationWays200Response
from pysevdesk.models.get_contact_addresses200_response import GetContactAddresses200Response
from pysevdesk.models.get_contact_field_settings200_response import GetContactFieldSettings200Response
from pysevdesk.models.get_contact_fields200_response import GetContactFields200Response
from pysevdesk.models.get_contact_tabs_item_count_by_id200_response import GetContactTabsItemCountById200Response
from pysevdesk.models.get_credit_notes200_response import GetCreditNotes200Response
from pysevdesk.models.get_discounts200_response import GetDiscounts200Response
from pysevdesk.models.get_invoice_positions_by_id200_response import GetInvoicePositionsById200Response
from pysevdesk.models.get_invoices200_response import GetInvoices200Response
from pysevdesk.models.get_letterpapers_with_thumb200_response import GetLetterpapersWithThumb200Response
from pysevdesk.models.get_letterpapers_with_thumb200_response_letterpapers_inner import GetLetterpapersWithThumb200ResponseLetterpapersInner
from pysevdesk.models.get_next_customer_number200_response import GetNextCustomerNumber200Response
from pysevdesk.models.get_order_positions_by_id200_response import GetOrderPositionsById200Response
from pysevdesk.models.get_orders200_response import GetOrders200Response
from pysevdesk.models.get_parts200_response import GetParts200Response
from pysevdesk.models.get_placeholder200_response import GetPlaceholder200Response
from pysevdesk.models.get_reference_count200_response import GetReferenceCount200Response
from pysevdesk.models.get_tag_relations200_response import GetTagRelations200Response
from pysevdesk.models.get_tags200_response import GetTags200Response
from pysevdesk.models.get_templates200_response import GetTemplates200Response
from pysevdesk.models.get_templates200_response_templates_inner import GetTemplates200ResponseTemplatesInner
from pysevdesk.models.get_transactions200_response import GetTransactions200Response
from pysevdesk.models.get_voucher_positions200_response import GetVoucherPositions200Response
from pysevdesk.models.get_vouchers200_response import GetVouchers200Response
from pysevdesk.models.getcredit_note_positions200_response import GetcreditNotePositions200Response
from pysevdesk.models.invoice_get_pdf200_response import InvoiceGetPdf200Response
from pysevdesk.models.invoice_get_xml200_response import InvoiceGetXml200Response
from pysevdesk.models.invoice_render201_response import InvoiceRender201Response
from pysevdesk.models.invoice_render201_response_parameters_inner import InvoiceRender201ResponseParametersInner
from pysevdesk.models.invoice_render201_response_parameters_inner_values_inner import InvoiceRender201ResponseParametersInnerValuesInner
from pysevdesk.models.invoice_render_request import InvoiceRenderRequest
from pysevdesk.models.invoice_reset_to_draft200_response import InvoiceResetToDraft200Response
from pysevdesk.models.invoice_reset_to_draft200_response_objects import InvoiceResetToDraft200ResponseObjects
from pysevdesk.models.invoice_reset_to_open200_response import InvoiceResetToOpen200Response
from pysevdesk.models.invoice_reset_to_open200_response_objects import InvoiceResetToOpen200ResponseObjects
from pysevdesk.models.invoice_send_by_request import InvoiceSendByRequest
from pysevdesk.models.model_accounting_contact import ModelAccountingContact
from pysevdesk.models.model_accounting_contact_contact import ModelAccountingContactContact
from pysevdesk.models.model_accounting_contact_response import ModelAccountingContactResponse
from pysevdesk.models.model_accounting_contact_response_contact import ModelAccountingContactResponseContact
from pysevdesk.models.model_accounting_contact_response_sev_client import ModelAccountingContactResponseSevClient
from pysevdesk.models.model_accounting_contact_update import ModelAccountingContactUpdate
from pysevdesk.models.model_accounting_contact_update_contact import ModelAccountingContactUpdateContact
from pysevdesk.models.model_change_layout import ModelChangeLayout
from pysevdesk.models.model_change_layout_response import ModelChangeLayoutResponse
from pysevdesk.models.model_change_layout_response_metadaten import ModelChangeLayoutResponseMetadaten
from pysevdesk.models.model_change_layout_response_metadaten_thumbs_inner import ModelChangeLayoutResponseMetadatenThumbsInner
from pysevdesk.models.model_change_layout_response_metadaten_thumbs_inner_values_inner import ModelChangeLayoutResponseMetadatenThumbsInnerValuesInner
from pysevdesk.models.model_check_account_response import ModelCheckAccountResponse
from pysevdesk.models.model_check_account_response_sev_client import ModelCheckAccountResponseSevClient
from pysevdesk.models.model_check_account_transaction import ModelCheckAccountTransaction
from pysevdesk.models.model_check_account_transaction_check_account import ModelCheckAccountTransactionCheckAccount
from pysevdesk.models.model_check_account_transaction_response import ModelCheckAccountTransactionResponse
from pysevdesk.models.model_check_account_transaction_response_check_account import ModelCheckAccountTransactionResponseCheckAccount
from pysevdesk.models.model_check_account_transaction_response_sev_client import ModelCheckAccountTransactionResponseSevClient
from pysevdesk.models.model_check_account_transaction_response_source_transaction import ModelCheckAccountTransactionResponseSourceTransaction
from pysevdesk.models.model_check_account_transaction_response_target_transaction import ModelCheckAccountTransactionResponseTargetTransaction
from pysevdesk.models.model_check_account_transaction_sev_client import ModelCheckAccountTransactionSevClient
from pysevdesk.models.model_check_account_transaction_source_transaction import ModelCheckAccountTransactionSourceTransaction
from pysevdesk.models.model_check_account_transaction_target_transaction import ModelCheckAccountTransactionTargetTransaction
from pysevdesk.models.model_check_account_transaction_update import ModelCheckAccountTransactionUpdate
from pysevdesk.models.model_check_account_transaction_update_check_account import ModelCheckAccountTransactionUpdateCheckAccount
from pysevdesk.models.model_check_account_update import ModelCheckAccountUpdate
from pysevdesk.models.model_communication_way import ModelCommunicationWay
from pysevdesk.models.model_communication_way_contact import ModelCommunicationWayContact
from pysevdesk.models.model_communication_way_key import ModelCommunicationWayKey
from pysevdesk.models.model_communication_way_response import ModelCommunicationWayResponse
from pysevdesk.models.model_communication_way_response_contact import ModelCommunicationWayResponseContact
from pysevdesk.models.model_communication_way_response_key import ModelCommunicationWayResponseKey
from pysevdesk.models.model_communication_way_response_sev_client import ModelCommunicationWayResponseSevClient
from pysevdesk.models.model_communication_way_sev_client import ModelCommunicationWaySevClient
from pysevdesk.models.model_communication_way_update import ModelCommunicationWayUpdate
from pysevdesk.models.model_communication_way_update_contact import ModelCommunicationWayUpdateContact
from pysevdesk.models.model_communication_way_update_key import ModelCommunicationWayUpdateKey
from pysevdesk.models.model_contact import ModelContact
from pysevdesk.models.model_contact_address import ModelContactAddress
from pysevdesk.models.model_contact_address_response import ModelContactAddressResponse
from pysevdesk.models.model_contact_address_response_category import ModelContactAddressResponseCategory
from pysevdesk.models.model_contact_address_response_contact import ModelContactAddressResponseContact
from pysevdesk.models.model_contact_address_response_country import ModelContactAddressResponseCountry
from pysevdesk.models.model_contact_address_response_sev_client import ModelContactAddressResponseSevClient
from pysevdesk.models.model_contact_address_update import ModelContactAddressUpdate
from pysevdesk.models.model_contact_address_update_contact import ModelContactAddressUpdateContact
from pysevdesk.models.model_contact_address_update_country import ModelContactAddressUpdateCountry
from pysevdesk.models.model_contact_category import ModelContactCategory
from pysevdesk.models.model_contact_custom_field import ModelContactCustomField
from pysevdesk.models.model_contact_custom_field_contact import ModelContactCustomFieldContact
from pysevdesk.models.model_contact_custom_field_contact_custom_field_setting import ModelContactCustomFieldContactCustomFieldSetting
from pysevdesk.models.model_contact_custom_field_response import ModelContactCustomFieldResponse
from pysevdesk.models.model_contact_custom_field_response_contact import ModelContactCustomFieldResponseContact
from pysevdesk.models.model_contact_custom_field_response_sev_client import ModelContactCustomFieldResponseSevClient
from pysevdesk.models.model_contact_custom_field_setting import ModelContactCustomFieldSetting
from pysevdesk.models.model_contact_custom_field_setting_response import ModelContactCustomFieldSettingResponse
from pysevdesk.models.model_contact_custom_field_setting_response_sev_client import ModelContactCustomFieldSettingResponseSevClient
from pysevdesk.models.model_contact_custom_field_setting_update import ModelContactCustomFieldSettingUpdate
from pysevdesk.models.model_contact_custom_field_update import ModelContactCustomFieldUpdate
from pysevdesk.models.model_contact_custom_field_update_contact_custom_field_setting import ModelContactCustomFieldUpdateContactCustomFieldSetting
from pysevdesk.models.model_contact_parent import ModelContactParent
from pysevdesk.models.model_contact_response import ModelContactResponse
from pysevdesk.models.model_contact_response_category import ModelContactResponseCategory
from pysevdesk.models.model_contact_response_parent import ModelContactResponseParent
from pysevdesk.models.model_contact_response_sev_client import ModelContactResponseSevClient
from pysevdesk.models.model_contact_update import ModelContactUpdate
from pysevdesk.models.model_contact_update_category import ModelContactUpdateCategory
from pysevdesk.models.model_contact_update_parent import ModelContactUpdateParent
from pysevdesk.models.model_create_invoice_from_order import ModelCreateInvoiceFromOrder
from pysevdesk.models.model_create_invoice_from_order_order import ModelCreateInvoiceFromOrderOrder
from pysevdesk.models.model_create_packing_list_from_order import ModelCreatePackingListFromOrder
from pysevdesk.models.model_credit_note import ModelCreditNote
from pysevdesk.models.model_credit_note_address_country import ModelCreditNoteAddressCountry
from pysevdesk.models.model_credit_note_contact import ModelCreditNoteContact
from pysevdesk.models.model_credit_note_contact_person import ModelCreditNoteContactPerson
from pysevdesk.models.model_credit_note_create_user import ModelCreditNoteCreateUser
from pysevdesk.models.model_credit_note_mail_response import ModelCreditNoteMailResponse
from pysevdesk.models.model_credit_note_mail_response_sev_client import ModelCreditNoteMailResponseSevClient
from pysevdesk.models.model_credit_note_pos import ModelCreditNotePos
from pysevdesk.models.model_credit_note_pos_credit_note import ModelCreditNotePosCreditNote
from pysevdesk.models.model_credit_note_pos_part import ModelCreditNotePosPart
from pysevdesk.models.model_credit_note_pos_response import ModelCreditNotePosResponse
from pysevdesk.models.model_credit_note_pos_response_credit_note import ModelCreditNotePosResponseCreditNote
from pysevdesk.models.model_credit_note_pos_response_part import ModelCreditNotePosResponsePart
from pysevdesk.models.model_credit_note_pos_response_sev_client import ModelCreditNotePosResponseSevClient
from pysevdesk.models.model_credit_note_pos_response_unity import ModelCreditNotePosResponseUnity
from pysevdesk.models.model_credit_note_pos_sev_client import ModelCreditNotePosSevClient
from pysevdesk.models.model_credit_note_pos_unity import ModelCreditNotePosUnity
from pysevdesk.models.model_credit_note_response import ModelCreditNoteResponse
from pysevdesk.models.model_credit_note_response_address_country import ModelCreditNoteResponseAddressCountry
from pysevdesk.models.model_credit_note_response_contact import ModelCreditNoteResponseContact
from pysevdesk.models.model_credit_note_response_contact_person import ModelCreditNoteResponseContactPerson
from pysevdesk.models.model_credit_note_response_create_user import ModelCreditNoteResponseCreateUser
from pysevdesk.models.model_credit_note_response_sev_client import ModelCreditNoteResponseSevClient
from pysevdesk.models.model_credit_note_response_tax_rule import ModelCreditNoteResponseTaxRule
from pysevdesk.models.model_credit_note_response_tax_set import ModelCreditNoteResponseTaxSet
from pysevdesk.models.model_credit_note_send_by_with_render import ModelCreditNoteSendByWithRender
from pysevdesk.models.model_credit_note_sev_client import ModelCreditNoteSevClient
from pysevdesk.models.model_credit_note_tax_set import ModelCreditNoteTaxSet
from pysevdesk.models.model_credit_note_update import ModelCreditNoteUpdate
from pysevdesk.models.model_credit_note_update_contact import ModelCreditNoteUpdateContact
from pysevdesk.models.model_credit_note_update_contact_person import ModelCreditNoteUpdateContactPerson
from pysevdesk.models.model_discount import ModelDiscount
from pysevdesk.models.model_discount_object import ModelDiscountObject
from pysevdesk.models.model_discounts_response import ModelDiscountsResponse
from pysevdesk.models.model_email import ModelEmail
from pysevdesk.models.model_email_order import ModelEmailOrder
from pysevdesk.models.model_email_sev_client import ModelEmailSevClient
from pysevdesk.models.model_invoice import ModelInvoice
from pysevdesk.models.model_invoice_address_country import ModelInvoiceAddressCountry
from pysevdesk.models.model_invoice_contact import ModelInvoiceContact
from pysevdesk.models.model_invoice_contact_person import ModelInvoiceContactPerson
from pysevdesk.models.model_invoice_origin import ModelInvoiceOrigin
from pysevdesk.models.model_invoice_payment_method import ModelInvoicePaymentMethod
from pysevdesk.models.model_invoice_pos import ModelInvoicePos
from pysevdesk.models.model_invoice_pos_invoice import ModelInvoicePosInvoice
from pysevdesk.models.model_invoice_pos_response import ModelInvoicePosResponse
from pysevdesk.models.model_invoice_pos_response_invoice import ModelInvoicePosResponseInvoice
from pysevdesk.models.model_invoice_pos_response_part import ModelInvoicePosResponsePart
from pysevdesk.models.model_invoice_pos_response_sev_client import ModelInvoicePosResponseSevClient
from pysevdesk.models.model_invoice_pos_response_unity import ModelInvoicePosResponseUnity
from pysevdesk.models.model_invoice_pos_sev_client import ModelInvoicePosSevClient
from pysevdesk.models.model_invoice_pos_unity import ModelInvoicePosUnity
from pysevdesk.models.model_invoice_response import ModelInvoiceResponse
from pysevdesk.models.model_invoice_response_address_country import ModelInvoiceResponseAddressCountry
from pysevdesk.models.model_invoice_response_contact import ModelInvoiceResponseContact
from pysevdesk.models.model_invoice_response_contact_person import ModelInvoiceResponseContactPerson
from pysevdesk.models.model_invoice_response_cost_centre import ModelInvoiceResponseCostCentre
from pysevdesk.models.model_invoice_response_origin import ModelInvoiceResponseOrigin
from pysevdesk.models.model_invoice_response_payment_method import ModelInvoiceResponsePaymentMethod
from pysevdesk.models.model_invoice_response_sev_client import ModelInvoiceResponseSevClient
from pysevdesk.models.model_invoice_response_tax_set import ModelInvoiceResponseTaxSet
from pysevdesk.models.model_invoice_sev_client import ModelInvoiceSevClient
from pysevdesk.models.model_invoice_tax_set import ModelInvoiceTaxSet
from pysevdesk.models.model_order import ModelOrder
from pysevdesk.models.model_order_address_country import ModelOrderAddressCountry
from pysevdesk.models.model_order_contact import ModelOrderContact
from pysevdesk.models.model_order_contact_person import ModelOrderContactPerson
from pysevdesk.models.model_order_origin import ModelOrderOrigin
from pysevdesk.models.model_order_pos import ModelOrderPos
from pysevdesk.models.model_order_pos_order import ModelOrderPosOrder
from pysevdesk.models.model_order_pos_response import ModelOrderPosResponse
from pysevdesk.models.model_order_pos_response_order import ModelOrderPosResponseOrder
from pysevdesk.models.model_order_pos_response_part import ModelOrderPosResponsePart
from pysevdesk.models.model_order_pos_response_sev_client import ModelOrderPosResponseSevClient
from pysevdesk.models.model_order_pos_response_unity import ModelOrderPosResponseUnity
from pysevdesk.models.model_order_pos_sev_client import ModelOrderPosSevClient
from pysevdesk.models.model_order_pos_update import ModelOrderPosUpdate
from pysevdesk.models.model_order_response import ModelOrderResponse
from pysevdesk.models.model_order_response_address_country import ModelOrderResponseAddressCountry
from pysevdesk.models.model_order_response_contact import ModelOrderResponseContact
from pysevdesk.models.model_order_response_contact_person import ModelOrderResponseContactPerson
from pysevdesk.models.model_order_response_create_user import ModelOrderResponseCreateUser
from pysevdesk.models.model_order_response_origin import ModelOrderResponseOrigin
from pysevdesk.models.model_order_response_sev_client import ModelOrderResponseSevClient
from pysevdesk.models.model_order_response_tax_set import ModelOrderResponseTaxSet
from pysevdesk.models.model_order_tax_set import ModelOrderTaxSet
from pysevdesk.models.model_order_update import ModelOrderUpdate
from pysevdesk.models.model_order_update_address_country import ModelOrderUpdateAddressCountry
from pysevdesk.models.model_order_update_contact import ModelOrderUpdateContact
from pysevdesk.models.model_order_update_contact_person import ModelOrderUpdateContactPerson
from pysevdesk.models.model_order_update_create_user import ModelOrderUpdateCreateUser
from pysevdesk.models.model_order_update_sev_client import ModelOrderUpdateSevClient
from pysevdesk.models.model_order_update_tax_set import ModelOrderUpdateTaxSet
from pysevdesk.models.model_part import ModelPart
from pysevdesk.models.model_part_category import ModelPartCategory
from pysevdesk.models.model_part_sev_client import ModelPartSevClient
from pysevdesk.models.model_part_unity import ModelPartUnity
from pysevdesk.models.model_part_update import ModelPartUpdate
from pysevdesk.models.model_tag_create_response import ModelTagCreateResponse
from pysevdesk.models.model_tag_create_response_tag import ModelTagCreateResponseTag
from pysevdesk.models.model_tag_response import ModelTagResponse
from pysevdesk.models.model_tag_response_sev_client import ModelTagResponseSevClient
from pysevdesk.models.model_textparser_fetch_dictionary_entries_by_type_response import ModelTextparserFetchDictionaryEntriesByTypeResponse
from pysevdesk.models.model_textparser_fetch_dictionary_entries_by_type_response_value_inner import ModelTextparserFetchDictionaryEntriesByTypeResponseValueInner
from pysevdesk.models.model_voucher import ModelVoucher
from pysevdesk.models.model_voucher_cost_centre import ModelVoucherCostCentre
from pysevdesk.models.model_voucher_create_user import ModelVoucherCreateUser
from pysevdesk.models.model_voucher_document import ModelVoucherDocument
from pysevdesk.models.model_voucher_pos import ModelVoucherPos
from pysevdesk.models.model_voucher_pos_account_datev import ModelVoucherPosAccountDatev
from pysevdesk.models.model_voucher_pos_accounting_type import ModelVoucherPosAccountingType
from pysevdesk.models.model_voucher_pos_estimated_accounting_type import ModelVoucherPosEstimatedAccountingType
from pysevdesk.models.model_voucher_pos_response import ModelVoucherPosResponse
from pysevdesk.models.model_voucher_pos_response_accounting_type import ModelVoucherPosResponseAccountingType
from pysevdesk.models.model_voucher_pos_response_estimated_accounting_type import ModelVoucherPosResponseEstimatedAccountingType
from pysevdesk.models.model_voucher_pos_response_sev_client import ModelVoucherPosResponseSevClient
from pysevdesk.models.model_voucher_pos_response_voucher import ModelVoucherPosResponseVoucher
from pysevdesk.models.model_voucher_pos_sev_client import ModelVoucherPosSevClient
from pysevdesk.models.model_voucher_pos_voucher import ModelVoucherPosVoucher
from pysevdesk.models.model_voucher_response import ModelVoucherResponse
from pysevdesk.models.model_voucher_response_cost_centre import ModelVoucherResponseCostCentre
from pysevdesk.models.model_voucher_response_create_user import ModelVoucherResponseCreateUser
from pysevdesk.models.model_voucher_response_document import ModelVoucherResponseDocument
from pysevdesk.models.model_voucher_response_sev_client import ModelVoucherResponseSevClient
from pysevdesk.models.model_voucher_response_supplier import ModelVoucherResponseSupplier
from pysevdesk.models.model_voucher_response_tax_set import ModelVoucherResponseTaxSet
from pysevdesk.models.model_voucher_sev_client import ModelVoucherSevClient
from pysevdesk.models.model_voucher_supplier import ModelVoucherSupplier
from pysevdesk.models.model_voucher_tax_rule import ModelVoucherTaxRule
from pysevdesk.models.model_voucher_tax_set import ModelVoucherTaxSet
from pysevdesk.models.model_voucher_update import ModelVoucherUpdate
from pysevdesk.models.model_voucher_update_supplier import ModelVoucherUpdateSupplier
from pysevdesk.models.model_voucher_update_tax_set import ModelVoucherUpdateTaxSet
from pysevdesk.models.order_get_pdf200_response import OrderGetPdf200Response
from pysevdesk.models.order_send_by_request import OrderSendByRequest
from pysevdesk.models.part_get_stock200_response import PartGetStock200Response
from pysevdesk.models.receipt_guide_dto import ReceiptGuideDto
from pysevdesk.models.receipt_guide_dto_allowed_tax_rules_inner import ReceiptGuideDtoAllowedTaxRulesInner
from pysevdesk.models.report_contact200_response import ReportContact200Response
from pysevdesk.models.report_contact200_response_objects import ReportContact200ResponseObjects
from pysevdesk.models.report_contact_sev_query_parameter import ReportContactSevQueryParameter
from pysevdesk.models.report_invoice200_response import ReportInvoice200Response
from pysevdesk.models.report_invoice200_response_objects import ReportInvoice200ResponseObjects
from pysevdesk.models.report_invoice_sev_query_parameter import ReportInvoiceSevQueryParameter
from pysevdesk.models.report_order200_response import ReportOrder200Response
from pysevdesk.models.report_order200_response_objects import ReportOrder200ResponseObjects
from pysevdesk.models.report_order_sev_query_parameter import ReportOrderSevQueryParameter
from pysevdesk.models.report_order_sev_query_parameter_filter import ReportOrderSevQueryParameterFilter
from pysevdesk.models.report_order_sev_query_parameter_filter_contact import ReportOrderSevQueryParameterFilterContact
from pysevdesk.models.report_voucher200_response import ReportVoucher200Response
from pysevdesk.models.report_voucher200_response_objects import ReportVoucher200ResponseObjects
from pysevdesk.models.report_voucher_sev_query_parameter import ReportVoucherSevQueryParameter
from pysevdesk.models.save_credit_note import SaveCreditNote
from pysevdesk.models.save_credit_note_credit_note_pos_delete import SaveCreditNoteCreditNotePosDelete
from pysevdesk.models.save_credit_note_discount_delete import SaveCreditNoteDiscountDelete
from pysevdesk.models.save_credit_note_discount_save import SaveCreditNoteDiscountSave
from pysevdesk.models.save_credit_note_response import SaveCreditNoteResponse
from pysevdesk.models.save_invoice import SaveInvoice
from pysevdesk.models.save_invoice_discount_delete import SaveInvoiceDiscountDelete
from pysevdesk.models.save_invoice_discount_save_inner import SaveInvoiceDiscountSaveInner
from pysevdesk.models.save_invoice_invoice_pos_delete import SaveInvoiceInvoicePosDelete
from pysevdesk.models.save_invoice_response import SaveInvoiceResponse
from pysevdesk.models.save_order import SaveOrder
from pysevdesk.models.save_order_order_pos_delete import SaveOrderOrderPosDelete
from pysevdesk.models.save_order_response import SaveOrderResponse
from pysevdesk.models.save_voucher import SaveVoucher
from pysevdesk.models.save_voucher_response import SaveVoucherResponse
from pysevdesk.models.save_voucher_voucher_pos_delete import SaveVoucherVoucherPosDelete
from pysevdesk.models.send_credit_note_via_e_mail201_response import SendCreditNoteViaEMail201Response
from pysevdesk.models.send_credit_note_via_e_mail_request import SendCreditNoteViaEMailRequest
from pysevdesk.models.send_invoice_via_e_mail_request import SendInvoiceViaEMailRequest
from pysevdesk.models.sendorder_via_e_mail201_response import SendorderViaEMail201Response
from pysevdesk.models.sendorder_via_e_mail_request import SendorderViaEMailRequest
from pysevdesk.models.update_export_config_request import UpdateExportConfigRequest
from pysevdesk.models.update_tag_request import UpdateTagRequest
from pysevdesk.models.validation_error import ValidationError
from pysevdesk.models.validation_error_error import ValidationErrorError
from pysevdesk.models.voucher_reset_to_open200_response import VoucherResetToOpen200Response
from pysevdesk.models.voucher_reset_to_open200_response_objects import VoucherResetToOpen200ResponseObjects
from pysevdesk.models.voucher_upload_file201_response import VoucherUploadFile201Response
from pysevdesk.models.voucher_upload_file201_response_objects import VoucherUploadFile201ResponseObjects
from pysevdesk.models.voucher_upload_file_request import VoucherUploadFileRequest
