# coding: utf-8

"""
    sevdesk API

    <b>Contact:</b> To contact our support click  <a href='https://landing.sevdesk.de/service-support-center-technik'>here</a><br><br>   # General information  Welcome to our API!<br>  sevdesk offers you  the possibility of retrieving data using an interface, namely the sevdesk API, and making  changes without having to use the web UI. The sevdesk interface is a REST-Full API. All sevdesk  data and functions that are used in the web UI can also be controlled through the API.   # Cross-Origin Resource Sharing  This API features Cross-Origin Resource Sharing (CORS).<br>  It enables cross-domain communication from the browser.<br>  All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.    # Embedding resources  When retrieving resources by using this API, you might encounter nested resources in the resources you requested.<br>  For example, an invoice always contains a contact, of which you can see the ID and the object name.<br>  This API gives you the possibility to embed these resources completely into the resources you originally requested.<br>  Taking our invoice example, this would mean, that you would not only see the ID and object name of a contact, but rather the complete contact resource.    To embed resources, all you need to do is to add the query parameter 'embed' to your GET request.<br>  As values, you can provide the name of the nested resource.<br>  Multiple nested resources are also possible by providing multiple names, separated by a comma.    # Authentication and Authorization  The sevdesk API uses a token authentication to authorize calls. For this purpose every sevdesk administrator has one API token, which is a <b>hexadecimal string</b>  containing <b>32 characters</b>. The following clip shows where you can find the  API token if this is your first time with our API.<br><br> <video src='openAPI/img/findingTheApiToken.mp4' controls width='640' height='360'> Your browser cannot play this video.<br> This video explains how to find your sevDesk API token. </video> <br> The token will be needed in every request that you want to send and needs to be provided as a value of an <b>Authorization Header</b>.<br> In this case, we used some random API token. The example shows the token in the Authorization Header. <ul> <li>\"Authorization\" :<span style='color:red'>\"b7794de0085f5cd00560f160f290af38\"</span></li> </ul> The api tokens have an infinite lifetime and, in other words, exist as long as the sevdesk user exists.<br> For this reason, the user should <b>NEVER</b> be deleted.<br> If really necessary, it is advisable to save the api token as we will <b>NOT</b> be able to retrieve it afterwards!<br> It is also possible to generate a new API token, for example, if you want to prevent the usage of your sevdesk account by other people who got your current API token.<br> To achieve this, you just need to click on the \"generate new\" symbol to the right of your token and confirm it with your password.  # API News  To never miss API news and updates again, subscribe to our <b>free API newsletter</b> and get all relevant  information to keep your sevdesk software running smoothly. To subscribe, simply click <a href = 'https://landing.sevdesk.de/api-newsletter'><b>here</b></a> and confirm the email address to which we may send all updates relevant to you.  # API Requests  In our case, REST API requests need to be build by combining the following components. <table> <tr> <th><b>Component</b></th> <th><b>Description</b></th> </tr> <tr> <td>HTTP-Methods</td> <td> <ul> <li>GET (retrieve a resource)</li> <li>POST (create a resource)</li> <li>PUT (update a resource)</li> <li>DELETE (delete a resource)</li> </ul> </td> </tr> <tr> <td>URL of the API</td> <td><span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span></td> </tr> <tr> <td>URI of the resource</td> <td>The resource to query.<br>For example contacts in sevdesk:<br><br> <span style='color:red'>/Contact</span><br><br> Which will result in the following complete URL:<br><br> <span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span><span style='color:red'>/Contact</span> </td> </tr> <tr> <td>Query parameters</td> <td>Are attached by using the connectives <b>?</b> and <b>&</b> in the URL.<br></td> </tr> <tr> <td>Request headers</td> <td>Typical request headers are for example:<br> <div> <br> <ul> <li>Content-type</li> <li>Authorization</li> <li>Accept-Encoding</li> <li>User-Agent</li> <li>X-Version: Used for resource versioning see information below</li> <li>...</li> </ul> </div> </td> </tr> <tr>  <td>Response headers</td> <td> Typical response headers are for example:<br><br> <div> <ul>  <li>Deprecation: If a resource is deprecated we return true or a timestamp since when</li> <li>...</li> </ul> </div> </td> </tr> <tr> <td>Request body</td> <td>Mostly required in POST and PUT requests.<br> Often the request body contains json, in our case, it also accepts url-encoded data. </td> </tr> </table><br> <span style='color:red'>Note</span>: please pass a meaningful entry at the header \"User-Agent\".  If the \"User-Agent\" is set meaningfully, we can offer better support in case of queries from customers.<br> An example how such a \"User-Agent\" can look like: \"Integration-name by abc\". <br><br> This is a sample request for retrieving existing contacts in sevdesk using curl:<br><br> <img src='openAPI/img/GETRequest.PNG' alt='Get Request' height='150'><br><br> As you can see, the request contains all the components mentioned above.<br> It's HTTP method is GET, it has a correct endpoint  (<span style='color: #2aa198'>ht</span><span style='color: #2aa198'>tps://my.sevdesk.de/api/v1</span><span style='color:red'>/Contact</span>), query parameters and additional <b>header</b> information!<br><br> <b>Query Parameters</b><br><br> As you might have seen in the sample request above, there are several query parameters located in the url.<br> Those are mostly optional but prove to be very useful for a lot of requests as they can limit, extend, sort or filter the data you will get as a response.<br><br> These are the most used query parameter for the sevdesk API. <table> <tr> <th><b>Parameter</b></th> <th><b>Description</b></th> </tr> <tr> <td>embed</td> <td>Will extend some of the returned data.<br> A brief example can be found below.</td> </tr> <tr> <td>countAll</td> <td>\"countAll=true\" returns the number of items</td> </tr> </table> This is an example for the usage of the embed parameter.<br> The following first request will return all company contact entries in sevdesk up to a limit of 100 without any additional information and no offset.<br><br> <img src='openAPI/img/ContactQueryWithoutEmbed.PNG' width='900' height='850'><br><br> Now have a look at the category attribute located in the response.<br> Naturally, it just contains the id and the object name of the object but no further information.<br> We will now use the parameter embed with the value \"category\".<br><br> <img src='openAPI/img/ContactQueryWithEmbed.PNG' width='900' height='850'><br><br> As you can see, the category object is now extended and shows all the attributes and their corresponding values.<br><br> There are lot of other query parameters that can be used to filter the returned data for objects that match a certain pattern, however, those will not be mentioned here and instead can be found at the detail documentation of the most used API endpoints like contact, invoice or voucher.<br><br> <b>Pagination</b><br> <table> <tr> <th><b>Parameter</b></th> <th><b>Description</b></th> </tr> <tr> <td>limit</td> <td>Limits the number of entries that are returned.<br> Most useful in GET requests which will most likely deliver big sets of data like country or currency lists.<br> In this case, you can bypass the default limitation on returned entries by providing a high number. </td> </tr> <tr> <td>offset</td> <td>Specifies a certain offset for the data that will be returned.<br> As an example, you can specify \"offset=2\" if you want all entries except for the first two.</td> </tr> </table> Example: <ul><li><code>ht<span>tps://my.sevdesk.de/api/v1/Invoice?offset=20&limit=10<span></code></li></ul> <b>Request Headers</b><br><br> The HTTP request (response) headers allow the client as well as the server to pass additional information with the request.<br> They transfer the parameters and arguments which are important for transmitting data over HTTP.<br> Three headers which are useful / necessary when using the sevdesk API are \"Authorization, \"Accept\" and  \"Content-type\".<br> Underneath is a brief description of why and how they should be used.<br><br> <b>Authorization</b><br><br> Should be used to provide your API token in the header. <ul> <li>Authorization:<span style='color:red'>yourApiToken</span></li> </ul> <b>Accept</b><br><br> Specifies the format of the response.<br> Required for operations with a response body. <ul> <li>Accept:application/<span style='color:red'>format</span> </li> </ul> In our case, <code><span style='color:red'>format</span></code> could be replaced with <code>json</code> or <code>xml</code><br><br> <b>Content-type</b><br><br> Specifies which format is used in the request.<br> Is required for operations with a request body. <ul> <li>Content-type:application/<span style='color:red'>format</span></li> </ul> In our case,<code><span style='color:red'>format</span></code>could be replaced with <code>json</code> or <code>x-www-form-urlencoded</code> <br><br><b>API Responses</b><br><br> HTTP status codes<br> When calling the sevdesk API it is very likely that you will get a HTTP status code in the response.<br> Some API calls will also return JSON response bodies which will contain information about the resource.<br> Each status code which is returned will either be a <b>success</b> code or an <b>error</b> code.<br><br> Success codes <table> <tr> <th><b>Status code</b></th> <th><b>Description</b></th> </tr> <tr> <td><code>200 OK</code></td> <td>The request was successful</td> </tr> <tr> <td><code>201 Created</code></td> <td>Most likely to be found in the response of a <b>POST</b> request.<br> This code indicates that the desired resource was successfully created.</td> </tr> </table> <br>Error codes <table> <tr> <th><b>Status code</b></th> <th><b>Description</b></th> </tr> <tr> <td><code>400 Bad request</code></td> <td>The request you sent is most likely syntactically incorrect.<br> You should check if the parameters in the request body or the url are correct.</td> </tr> <tr> <td><code>401 Unauthorized</code></td> <td>The authentication failed.<br> Most likely caused by a missing or wrong API token.</td> </tr> <tr> <td><code>403 Forbidden</code></td> <td>You do not have the permission the access the resource which is requested.</td> </tr> <tr> <td><code>404 Not found</code></td> <td>The resource you specified does not exist.</td> </tr> <tr> <td><code>500 Internal server error</code></td> <td>An internal server error has occurred.<br> Normally this means that something went wrong on our side.<br> However, sometimes this error will appear if we missed to catch an error which is normally a 400 status code! </td> </tr> </table> <br><br> <b>Resource Versioning</b> <br><br> We use resource versioning to handle breaking changes for our endpoints, these are rarely used and will be communicated before we remove older versions.<br> To call a different version we use a specific header <code>X-Version</code> that should be filled with the desired version.<br> <ul>  <li>If you do not specify any version we assume <code>default</code></li> <li>If you specify a version that does not exist or was removed, you will get an error with information which versions are available</li> </ul> <table> <tr> <th>X-Version</th> <th>Description</th> </tr> <tr> <td><code>default</code></td> <td>Should always reference the oldest version.<br> If a specific resource is updated with a new version, <br> then the default version stays the same until the old version is deleted</td> </tr> <tr> <td><code>1.0</code> ... <code>1.9</code></td> <td>Our incrementally version for each resource independent<br> <b>Important</b>: A resource can be available via <code>default</code> but not <code>1.0</code></td> </tr> </table>  # Your First Request  After reading the introduction to our API, you should now be able to make your first call.<br> For testing our API, we would always recommend to create a trial account for sevdesk to prevent unwanted changes to your main account.<br> A trial account will be in the highest tariff (materials management), so every sevdesk function can be tested!   To start testing we would recommend one of the following tools: <ul> <li><a href='https://www.getpostman.com/'>Postman</a></li> <li><a href='https://curl.haxx.se/download.html'>cURL</a></li> </ul> This example will illustrate your first request, which is creating a new Contact in sevdesk.<br> <ol> <li>Download <a href='https://www.getpostman.com/'><b>Postman</b></a> for your desired system and start the application</li> <li>Enter <span><b>ht</span>tps://my.sevdesk.de/api/v1/Contact</b> as the url</li> <li>Create an authorization header and insert your API token as the value</li> <li>For this test, select <b>POST</b> as the HTTP method</li> <li>Go to <b>Headers</b> and enter the key-value pair <b>Content-type</b> + <b>application/x-www-form-urlencoded</b><br> As an alternative, you can just go to <b>Body</b> and select <b>x-www-form-urlencoded</b></li> <li>Now go to <b>Body</b> (if you are not there yet) and enter the key-value pairs as shown in the following picture<br><br> <img src='openAPI/img/FirstRequestPostman.PNG' width='900'><br><br></li> <li>Click on <b>Send</b>. Your response should now look like this:<br><br> <img src='openAPI/img/FirstRequestResponse.PNG' width='900'></li> </ol> As you can see, a successful response in this case returns a JSON-formatted response body containing the contact you just created.<br> For keeping it simple, this was only a minimal example of creating a contact.<br> There are however numerous combinations of parameters that you can provide which add information to your contact.  # sevdesk-Update 2.0  Started in 2024 we introduced a new era of bookkeeping in sevdesk. You can check if you already received the update by clicking on your profile in the top right in the sevdesk WebApp or by using the [Tools/bookkeepingSystemVersion endpoint](#tag/Basics/operation/bookkeepingSystemVersion).<br> The old version will be available for some customers until the end of 2024. In this short list we have outlined the changed endpoints with links to jump to the descriptions. If you received the [api newsletter](https://landing.sevdesk.de/api-newsletter) you already know what changed. Otherwise you can check the api changes [here](https://tech.sevdesk.com/api_news/posts/2024_04_04-system-update-breaking-changes/).  ## Check your bookkeeping system version  With this endpoint you can check which version you / your client uses. On that basis you must use the old or new versions of the endpoints. [Tools/bookkeepingSystemVersion Endpoint](#tag/Basics/operation/bookkeepingSystemVersion)  ## Tax Rules  <I><b>(affects the properties taxType and taxSet)</b></I><br> With sevdesk-Update 2.0 we changed the available tax rules. Due to a high likeliness of non-compliant accounting, we won't support the following tax type with the sevdesk-Update 2.0 anymore:  `taxType = custom (this includes 'taxSet': ... )`  If you only use <code>taxType = default</code>, <code>taxType = eu</code> and / or <code>taxType = ss</code>, these tax types will automatically be mapped to the new tax rules for a transition period, but you have to make sure the taxRate used in positions is within the allowed ones (you may use the [ReceiptGuidance endpoint](#tag/Voucher/operation/forAllAccounts) for that), otherwise the API will return a validation error (HTTP status code 422). For [orders](#tag/Order), [invoices](#tag/Invoice), [vouchers](#tag/Voucher) and [credit notes](#tag/CreditNote) that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned.<br> So orders, invoices, vouchers and credit notes created within sevdesk system version 1.0 still have a taxType in the response. When they are created in sevdesk-Update 2.0 they will have a taxRule instead.<br> You can continue to use taxType at first, but we recommend switching to taxRule as there are new options available that were not previously supported.<br> For orders, invoices, vouchers and credit notes that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned. This documentation holds the most current version of the endpoints.<br> Here are lists of the currently available tax rules, sorted by their use case, structured into revenue/expense and 'Regelbesteuerer'/'Kleinunternehmer'.  #### VAT rules for 'Regelbesteuerung' in sevdesk-Update 2.0 (Revenue)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> <th>Unsupported use cases</th> </tr> <tr> <td>Umsatzsteuerpflichtige Umsätze</td> <td><code>'taxRule': 1</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'default'</code></td> <td>-</td> </tr> <tr> <td>Ausfuhren</td> <td><code>'taxRule': 2</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Innergemeinschaftliche Lieferungen</td> <td><code>'taxRule': 3</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'eu'</code></td> <td>-</td> </tr> <tr> <td>Steuerfreie Umsätze §4 UStG</td> <td><code>'taxRule': 4</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b UStG</td> <td><code>'taxRule': 5</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> <td>-</td> </tr> <tr> <td>Nicht im Inland steuerbare Leistung</td> <td><code>'taxRule': 17</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'noteu'</code></td> <td> <ul> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (goods)</td> <td><code>'taxRule': 18</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (electronic service)</td> <td><code>'taxRule': 19</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> <tr> <td>One Stop Shop (other service)</td> <td><code>'taxRule': 20</code></td> <td> <ul> <li>depending on country</li> </ul> </td> <td>-</td> <td> <ul> <li>Usage in vouchers</li> <li>Creation as e-invoice</li> <li>Creation of an invoice with a custom revenue account (<code>accountDatev</code>)</li> <li>Creation of an advance invoice</li> <li>Creation of a partial invoice</li> <li>Creation of a final invoice</li> </ul> </td> </tr> </table>   See the <a href=\"#tag/Invoice/operation/createInvoiceFromOrder\">example request</a> to create a normal invoice <code>\"invoiceType\": \"RE\"</code> from an order that uses a tax rule that does not support advance, partial or final invoices.    #### VAT rules for 'Regelbesteuerung' in sevdesk-Update 2.0 (Expense)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Innergemeinschaftliche Erwerbe</td> <td><code>'taxRule': 8</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 9</code></td> <td> <ul> <li>0.0</li> <li>7.0</li> <li>19.0</li> </ul> </td> <td><code>'taxType': 'default'</code></td> </tr> <tr> <td>Nicht vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 10</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b Abs. 2 UStG mit Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 12</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 13</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> <tr> <td>Reverse Charge gem. §13b Abs. 1 EU Umsätze 0% (19%)</td> <td><code>'taxRule': 14</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> </table>    #### VAT rules for small business owner ('Kleinunternehmer') in sevdesk-Update 2.0 (Revenue)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Steuer nicht erhoben nach §19UStG</td> <td><code>'taxRule': 11</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'ss'</code></td> </tr> </table>    #### VAT rules for small business owner ('Kleinunternehmer') in sevdesk-Update 2.0 (Expense)  <table> <tr> <th>VAT Rule</th> <th>New Property</th> <th>Allowed taxRate in positions</th> <th>Old property (deprecated)</th> </tr> <tr> <td>Nicht vorsteuerabziehbare Aufwendungen</td> <td><code>'taxRule': 10</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td><code>'taxType': 'ss'</code></td> </tr> <tr> <td>Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)</td> <td><code>'taxRule': 13</code></td> <td> <ul> <li>0.0</li> </ul> </td> <td>-</td> </tr> </table>    ## Booking Accounts  <I><b>(affects the property accountingType)</b></I><br> With sevdesk-Update 2.0 we changed the available booking accounts and their combinatorics. If you use accountingTypes with SKR numbers that are still available in our receipt guidance, you do not have to change anything in your requests. These booking accounts will automatically be mapped to the new representation (Account Datev). But you have to make sure the taxRate used in positions and taxRule used in the voucher is within the allowed ones (check the [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)) of the provided booking account, otherwise the API will return a validation error (HTTP status code 422). For orders, invoices, vouchers and credit notes in that were created within sevdesk-Update 2.0 the response will change in all endpoints were these objects are returned.  ## Receipt Guidance  To help you decide which account can be used in conjunction with which tax rules, tax rates and documents, we created several guidance endpoints just there for you to get helpful information. You can find the descriptions in the changes section for Vouchers below or jump directly to the endpoint description by using this link: [Receipt Guidance](#tag/Voucher/operation/forAllAccounts).<br> Receipt Guidance is planned to give you guidance in which account you can pick (depending on your filter criteria and the client settings (e.g. 'Kleinunternehmer')) and which tax rate and [tax rules](#section/sevdesk-Update-2.0/Tax-Rules) are comptaible with them.   ## Vouchers   ### Saving a new voucher ([Voucher/Factory/saveVoucher](#tag/Voucher/operation/voucherFactorySaveVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Custom vat regulations (taxType = custom and provided taxSet)</li> <li>Only specific tax rates and booking accounts are available. Check [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)</li> <li>Custom accounting types do not work anymore</li> <li>Using an asset booking account without creating an asset is no longer possible</li> <li>A voucher can not be directly set to paid anymore, therefore only status <code>DRAFT (50)</code> or <code>UNPAID / DUE (100)</code> are possible when creating a new voucher. Use the [/api/v1/Voucher/{voucherId}/bookAmount endpoint](#tag/Voucher/operation/bookVoucher) to set a voucher to paid</li> <li>Setting or changing the property enshrined. Use our new endpoint [/api/v1/Voucher/{voucherId}/enshrine](#tag/Voucher/operation/voucherEnshrine) to enshrine a voucher</li> </ol>  ### Get or update an existing voucher ([Voucher/{voucherId}](#tag/Voucher/operation/updateVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Custom vat regulations (taxType = custom and provided taxSet)</li> <li>See [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts) to check which tax rates are available in conjunction with which tax rules</li> </ol>  ### Book a voucher ([Voucher/{voucherId}](#tag/Voucher/operation/bookVoucher))  Following use cases do not work anymore or have changed: <ol> <li>Voucher with negative voucher positions can not use 'cash discount' as a payment difference anymore</li> <li>A Voucher can only be booked when it was registered beforehand (see above)</li> <li>Based on the combination of voucher positions some payment difference reasons are not possible anymore</li> <li>The currency fluctuation (CF) type is no longer supported as a payment difference reason</li> </ol>  ## Banking  Following use cases do not work anymore or have changed: <ol> <li>Setting or changing the property enshrined will now only be available by using the [appropriate enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)</li> </ol>  ## Invoicing  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct invoices are created which than can be further processed in sevdesk. Following use cases do not work anymore or have changed: <ol> <li>Creating an invoice with taxType <code>custom</code> does not work anymore</li> <li>Processing an invoice beyond status <code>DRAFT (100)</code> without a contact does not work anymore</li> <li>Advanced invoices (<code>invoiceType: 'AR'</code>) and partial invoices (<code>invoiceType: 'TR'</code>) can only be created with the tax rule 'Umsatzsteuerpflichtige Umsätze (taxRule: 1)'(for Regelbesteuerer) or 'Steuer nicht erhoben nach §19 UStG (taxRule: 11)'(for Kleinunternehmer)</li> <li>Creating a dunning (<code>invoiceType: 'MA'</code>) with the value of property <code>reminderCharge</code> greater than 0 does not work anymore</li> <li>Creating an advanced invoice (<code>invoiceType: 'AR'</code>), a partial invoice (<code>invoiceType: 'TR'</code>) or a final invoice (<code>invoiceType: 'ER'</code>) with a currency deviating from the clients <code>defaultCurrency</code> is not possible anymore</li> <li>Changing the status manually does not work anymore (see 'Removed endpoint /Invoice/{invoiceId}/changeStatus' below)</li> <li>Enshrining now has to be done by using the [enshrine endpoint](#tag/Invoice/operation/invoiceEnshrine) (see below)</li> </ol>  ### Saving an invoice ([Invoice/Factory/saveInvoice](#tag/Invoice/operation/createInvoiceByFactory))  Following use cases do not work anymore or have changed: <ol> <li>Invoices can only be created with the status <code>DRAFT (100)</code> and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)) to automatically change the status accordingly</li> <li>Setting or changing the property <code>enshrined</code> is now only possible by using the [enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)</li> </ol>  ### Using an order to create an invoice ([Invoice/Factory/createInvoiceFromOrder](#tag/Invoice/operation/createInvoiceFromOrder))  Following use cases do not work anymore or have changed: <ol> <li>Creating a final invoice (partialType: 'ER') is not possible if an advanced invoice (partialType: 'AR') or partial invoice (partialType: 'TR') exists. This functionality will be added in a later update</li> </ol>  ### Removed endpoint /Invoice/{invoiceId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: <ul> <li>[Invoice/{invoiceId}/sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)</li> <li>[Invoice/{invoiceId}/sendBy](#tag/Invoice/operation/invoiceSendBy)</li> <li>[Invoice/{invoiceId}/bookAmount](#tag/Invoice/operation/bookInvoice)</li> <li>[Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)</li> <li>[Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)</li> </ul>  ### New endpoint [Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)  This new endpoint can be used to reset the status of an invoice to <code>DRAFT (100)</code>.  ### New endpoint [Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)  This new endpoint can be used to reset the status of an invoice to <code>OPEN (200)</code>.  ### New endpoint [Invoice/{invoiceId}/enshrine]((#tag/Invoice/operation/invoiceEnshrine))  The enshrine endpoint is now used to set the property <code>enshrined</code>. <b>This operation CAN NOT be undone due to legal reasons!</b>  ## Credit Notes  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct credit notes are created which than can be further processed in sevdesk. Due to the move from taxTypes/taxSets to taxRules you need to check the compatibility of the taxRules in combination with the tax rates. Following use cases do not work anymore or have changed: <ol> <li>Creating a credit note without a date of delivery (<code>deliveryDateUntil</code>) for an invoice that has a date of delivery (<code>deliveryDateUntil</code>) is no longer possible</li> <li>Creating a credit note with a date of delivery (<code>deliveryDateUntil</code>) for an invoice that has no date of delivery (<code>deliveryDateUntil</code>) is no longer possible</li> <li>Creating a credit note with a date of delivery (<code>deliveryDateUntil</code>) that is before the date of delivery (<code>deliveryDateUntil</code>) of the invoice is no longer possible</li> <li>Creating a credit note for an advanced invoice (<code>invoiceType: 'AR'</code>) or partial invoice (<code>invoiceType: 'TR'</code>) is no longer possible</li> <li>Creating a credit note for a voucher is no longer possible</li> <li>Creating a credit note with a <code>bookingCategory</code> other than <code>UNDERACHIEVEMENT</code> is no longer possible</li> <li>Currency fluctuation (CF) is no longer supported as a payment difference</li> </ol>  ### Saving a credit note ([CreditNote/Factory/saveCreditNote](#tag/CreditNote/operation/createcreditNote))  Following use cases do not work anymore or have changed: <ol> <li>Credit notes can only be created with the status <code>DRAFT (100)</code> and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)) to automatically change the status accordingly</li> <li>Enshrining now has to be done by using the enshrine endpoint (see below)</li> </ol>  ### Removed endpoint /CreditNote/Factory/createFromVoucher  The endpoint will be removed. It is not possible anymore to create credit notes for vouchers within sevdesk-Update 2.0. The endpoint continues to stay available for existing sevdesk system version 1.0 clients.  ### Removed endpoint /CreditNote/{creditNoteId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: <ul> <li>[CreditNote/{creditNoteId}/sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)</li> <li>[CreditNote/{creditNoteId}/sendBy](#tag/CreditNote/operation/creditNoteSendBy)</li> <li>[CreditNote/{creditNoteId}/bookAmount](#tag/CreditNote/operation/bookCreditNote)</li> <li>[CreditNote/{creditNoteId}/resetToDraft](#tag/CreditNote/operation/creditNoteResetToDraft)</li> <li>[CreditNote/{creditNoteId}/resetToOpen](#tag/CreditNote/operation/creditNoteResetToOpen)</li> </ul>  ### New endpoint CreditNote/{creditNoteId}/resetToDraft  This new endpoint can be used to reset the status of a credit note to <code>DRAFT (100)</code>. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToDraft).  ### New endpoint CreditNote/{creditNoteId}/resetToOpen  This new endpoint can be used to reset the status of a credit note to <code>OPEN (200)</code>. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToOpen).  ### New endpoint CreditNote/{creditNoteId}/enshrine  [The enshrine endpoint](#tag/CreditNote/operation/creditNoteEnshrine) is now used to set the property <code>enshrined</code>. <b>This operation CAN NOT be undone due to legal reasons!</b> ## Parts   ### General stricter validation in PUT and POST endpoints  Following use cases do not work anymore or have changed: <ol> <li>Creating products with a tax rate other than 0.0, 7.0 and 19.0 is no longer possible</li> </ol> 

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from setuptools import setup, find_packages  # noqa: H301

# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools
NAME = "pysevdesk"
VERSION = "0.1.0"
PYTHON_REQUIRES = ">= 3.8"
REQUIRES = [
    "urllib3 >= 1.25.3, < 3.0.0",
    "python-dateutil >= 2.8.2",
    "pydantic >= 2",
    "typing-extensions >= 4.7.1",
]

setup(
    name=NAME,
    version=VERSION,
    description="sevdesk API",
    author="OpenAPI Generator community",
    author_email="team@openapitools.org",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "sevdesk API"],
    install_requires=REQUIRES,
    packages=find_packages(exclude=["test", "tests"]),
    include_package_data=True,
    long_description_content_type='text/markdown',
    long_description="""\
    &lt;b&gt;Contact:&lt;/b&gt; To contact our support click  &lt;a href&#x3D;&#39;https://landing.sevdesk.de/service-support-center-technik&#39;&gt;here&lt;/a&gt;&lt;br&gt;&lt;br&gt;   # General information  Welcome to our API!&lt;br&gt;  sevdesk offers you  the possibility of retrieving data using an interface, namely the sevdesk API, and making  changes without having to use the web UI. The sevdesk interface is a REST-Full API. All sevdesk  data and functions that are used in the web UI can also be controlled through the API.   # Cross-Origin Resource Sharing  This API features Cross-Origin Resource Sharing (CORS).&lt;br&gt;  It enables cross-domain communication from the browser.&lt;br&gt;  All responses have a wildcard same-origin which makes them completely public and accessible to everyone, including any code on any site.    # Embedding resources  When retrieving resources by using this API, you might encounter nested resources in the resources you requested.&lt;br&gt;  For example, an invoice always contains a contact, of which you can see the ID and the object name.&lt;br&gt;  This API gives you the possibility to embed these resources completely into the resources you originally requested.&lt;br&gt;  Taking our invoice example, this would mean, that you would not only see the ID and object name of a contact, but rather the complete contact resource.    To embed resources, all you need to do is to add the query parameter &#39;embed&#39; to your GET request.&lt;br&gt;  As values, you can provide the name of the nested resource.&lt;br&gt;  Multiple nested resources are also possible by providing multiple names, separated by a comma.    # Authentication and Authorization  The sevdesk API uses a token authentication to authorize calls. For this purpose every sevdesk administrator has one API token, which is a &lt;b&gt;hexadecimal string&lt;/b&gt;  containing &lt;b&gt;32 characters&lt;/b&gt;. The following clip shows where you can find the  API token if this is your first time with our API.&lt;br&gt;&lt;br&gt; &lt;video src&#x3D;&#39;openAPI/img/findingTheApiToken.mp4&#39; controls width&#x3D;&#39;640&#39; height&#x3D;&#39;360&#39;&gt; Your browser cannot play this video.&lt;br&gt; This video explains how to find your sevDesk API token. &lt;/video&gt; &lt;br&gt; The token will be needed in every request that you want to send and needs to be provided as a value of an &lt;b&gt;Authorization Header&lt;/b&gt;.&lt;br&gt; In this case, we used some random API token. The example shows the token in the Authorization Header. &lt;ul&gt; &lt;li&gt;\&quot;Authorization\&quot; :&lt;span style&#x3D;&#39;color:red&#39;&gt;\&quot;b7794de0085f5cd00560f160f290af38\&quot;&lt;/span&gt;&lt;/li&gt; &lt;/ul&gt; The api tokens have an infinite lifetime and, in other words, exist as long as the sevdesk user exists.&lt;br&gt; For this reason, the user should &lt;b&gt;NEVER&lt;/b&gt; be deleted.&lt;br&gt; If really necessary, it is advisable to save the api token as we will &lt;b&gt;NOT&lt;/b&gt; be able to retrieve it afterwards!&lt;br&gt; It is also possible to generate a new API token, for example, if you want to prevent the usage of your sevdesk account by other people who got your current API token.&lt;br&gt; To achieve this, you just need to click on the \&quot;generate new\&quot; symbol to the right of your token and confirm it with your password.  # API News  To never miss API news and updates again, subscribe to our &lt;b&gt;free API newsletter&lt;/b&gt; and get all relevant  information to keep your sevdesk software running smoothly. To subscribe, simply click &lt;a href &#x3D; &#39;https://landing.sevdesk.de/api-newsletter&#39;&gt;&lt;b&gt;here&lt;/b&gt;&lt;/a&gt; and confirm the email address to which we may send all updates relevant to you.  # API Requests  In our case, REST API requests need to be build by combining the following components. &lt;table&gt; &lt;tr&gt; &lt;th&gt;&lt;b&gt;Component&lt;/b&gt;&lt;/th&gt; &lt;th&gt;&lt;b&gt;Description&lt;/b&gt;&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;HTTP-Methods&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;GET (retrieve a resource)&lt;/li&gt; &lt;li&gt;POST (create a resource)&lt;/li&gt; &lt;li&gt;PUT (update a resource)&lt;/li&gt; &lt;li&gt;DELETE (delete a resource)&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;URL of the API&lt;/td&gt; &lt;td&gt;&lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;ht&lt;/span&gt;&lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;tps://my.sevdesk.de/api/v1&lt;/span&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;URI of the resource&lt;/td&gt; &lt;td&gt;The resource to query.&lt;br&gt;For example contacts in sevdesk:&lt;br&gt;&lt;br&gt; &lt;span style&#x3D;&#39;color:red&#39;&gt;/Contact&lt;/span&gt;&lt;br&gt;&lt;br&gt; Which will result in the following complete URL:&lt;br&gt;&lt;br&gt; &lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;ht&lt;/span&gt;&lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;tps://my.sevdesk.de/api/v1&lt;/span&gt;&lt;span style&#x3D;&#39;color:red&#39;&gt;/Contact&lt;/span&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Query parameters&lt;/td&gt; &lt;td&gt;Are attached by using the connectives &lt;b&gt;?&lt;/b&gt; and &lt;b&gt;&amp;&lt;/b&gt; in the URL.&lt;br&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Request headers&lt;/td&gt; &lt;td&gt;Typical request headers are for example:&lt;br&gt; &lt;div&gt; &lt;br&gt; &lt;ul&gt; &lt;li&gt;Content-type&lt;/li&gt; &lt;li&gt;Authorization&lt;/li&gt; &lt;li&gt;Accept-Encoding&lt;/li&gt; &lt;li&gt;User-Agent&lt;/li&gt; &lt;li&gt;X-Version: Used for resource versioning see information below&lt;/li&gt; &lt;li&gt;...&lt;/li&gt; &lt;/ul&gt; &lt;/div&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt;  &lt;td&gt;Response headers&lt;/td&gt; &lt;td&gt; Typical response headers are for example:&lt;br&gt;&lt;br&gt; &lt;div&gt; &lt;ul&gt;  &lt;li&gt;Deprecation: If a resource is deprecated we return true or a timestamp since when&lt;/li&gt; &lt;li&gt;...&lt;/li&gt; &lt;/ul&gt; &lt;/div&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Request body&lt;/td&gt; &lt;td&gt;Mostly required in POST and PUT requests.&lt;br&gt; Often the request body contains json, in our case, it also accepts url-encoded data. &lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;&lt;br&gt; &lt;span style&#x3D;&#39;color:red&#39;&gt;Note&lt;/span&gt;: please pass a meaningful entry at the header \&quot;User-Agent\&quot;.  If the \&quot;User-Agent\&quot; is set meaningfully, we can offer better support in case of queries from customers.&lt;br&gt; An example how such a \&quot;User-Agent\&quot; can look like: \&quot;Integration-name by abc\&quot;. &lt;br&gt;&lt;br&gt; This is a sample request for retrieving existing contacts in sevdesk using curl:&lt;br&gt;&lt;br&gt; &lt;img src&#x3D;&#39;openAPI/img/GETRequest.PNG&#39; alt&#x3D;&#39;Get Request&#39; height&#x3D;&#39;150&#39;&gt;&lt;br&gt;&lt;br&gt; As you can see, the request contains all the components mentioned above.&lt;br&gt; It&#39;s HTTP method is GET, it has a correct endpoint  (&lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;ht&lt;/span&gt;&lt;span style&#x3D;&#39;color: #2aa198&#39;&gt;tps://my.sevdesk.de/api/v1&lt;/span&gt;&lt;span style&#x3D;&#39;color:red&#39;&gt;/Contact&lt;/span&gt;), query parameters and additional &lt;b&gt;header&lt;/b&gt; information!&lt;br&gt;&lt;br&gt; &lt;b&gt;Query Parameters&lt;/b&gt;&lt;br&gt;&lt;br&gt; As you might have seen in the sample request above, there are several query parameters located in the url.&lt;br&gt; Those are mostly optional but prove to be very useful for a lot of requests as they can limit, extend, sort or filter the data you will get as a response.&lt;br&gt;&lt;br&gt; These are the most used query parameter for the sevdesk API. &lt;table&gt; &lt;tr&gt; &lt;th&gt;&lt;b&gt;Parameter&lt;/b&gt;&lt;/th&gt; &lt;th&gt;&lt;b&gt;Description&lt;/b&gt;&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;embed&lt;/td&gt; &lt;td&gt;Will extend some of the returned data.&lt;br&gt; A brief example can be found below.&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;countAll&lt;/td&gt; &lt;td&gt;\&quot;countAll&#x3D;true\&quot; returns the number of items&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; This is an example for the usage of the embed parameter.&lt;br&gt; The following first request will return all company contact entries in sevdesk up to a limit of 100 without any additional information and no offset.&lt;br&gt;&lt;br&gt; &lt;img src&#x3D;&#39;openAPI/img/ContactQueryWithoutEmbed.PNG&#39; width&#x3D;&#39;900&#39; height&#x3D;&#39;850&#39;&gt;&lt;br&gt;&lt;br&gt; Now have a look at the category attribute located in the response.&lt;br&gt; Naturally, it just contains the id and the object name of the object but no further information.&lt;br&gt; We will now use the parameter embed with the value \&quot;category\&quot;.&lt;br&gt;&lt;br&gt; &lt;img src&#x3D;&#39;openAPI/img/ContactQueryWithEmbed.PNG&#39; width&#x3D;&#39;900&#39; height&#x3D;&#39;850&#39;&gt;&lt;br&gt;&lt;br&gt; As you can see, the category object is now extended and shows all the attributes and their corresponding values.&lt;br&gt;&lt;br&gt; There are lot of other query parameters that can be used to filter the returned data for objects that match a certain pattern, however, those will not be mentioned here and instead can be found at the detail documentation of the most used API endpoints like contact, invoice or voucher.&lt;br&gt;&lt;br&gt; &lt;b&gt;Pagination&lt;/b&gt;&lt;br&gt; &lt;table&gt; &lt;tr&gt; &lt;th&gt;&lt;b&gt;Parameter&lt;/b&gt;&lt;/th&gt; &lt;th&gt;&lt;b&gt;Description&lt;/b&gt;&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;limit&lt;/td&gt; &lt;td&gt;Limits the number of entries that are returned.&lt;br&gt; Most useful in GET requests which will most likely deliver big sets of data like country or currency lists.&lt;br&gt; In this case, you can bypass the default limitation on returned entries by providing a high number. &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;offset&lt;/td&gt; &lt;td&gt;Specifies a certain offset for the data that will be returned.&lt;br&gt; As an example, you can specify \&quot;offset&#x3D;2\&quot; if you want all entries except for the first two.&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; Example: &lt;ul&gt;&lt;li&gt;&lt;code&gt;ht&lt;span&gt;tps://my.sevdesk.de/api/v1/Invoice?offset&#x3D;20&amp;limit&#x3D;10&lt;span&gt;&lt;/code&gt;&lt;/li&gt;&lt;/ul&gt; &lt;b&gt;Request Headers&lt;/b&gt;&lt;br&gt;&lt;br&gt; The HTTP request (response) headers allow the client as well as the server to pass additional information with the request.&lt;br&gt; They transfer the parameters and arguments which are important for transmitting data over HTTP.&lt;br&gt; Three headers which are useful / necessary when using the sevdesk API are \&quot;Authorization, \&quot;Accept\&quot; and  \&quot;Content-type\&quot;.&lt;br&gt; Underneath is a brief description of why and how they should be used.&lt;br&gt;&lt;br&gt; &lt;b&gt;Authorization&lt;/b&gt;&lt;br&gt;&lt;br&gt; Should be used to provide your API token in the header. &lt;ul&gt; &lt;li&gt;Authorization:&lt;span style&#x3D;&#39;color:red&#39;&gt;yourApiToken&lt;/span&gt;&lt;/li&gt; &lt;/ul&gt; &lt;b&gt;Accept&lt;/b&gt;&lt;br&gt;&lt;br&gt; Specifies the format of the response.&lt;br&gt; Required for operations with a response body. &lt;ul&gt; &lt;li&gt;Accept:application/&lt;span style&#x3D;&#39;color:red&#39;&gt;format&lt;/span&gt; &lt;/li&gt; &lt;/ul&gt; In our case, &lt;code&gt;&lt;span style&#x3D;&#39;color:red&#39;&gt;format&lt;/span&gt;&lt;/code&gt; could be replaced with &lt;code&gt;json&lt;/code&gt; or &lt;code&gt;xml&lt;/code&gt;&lt;br&gt;&lt;br&gt; &lt;b&gt;Content-type&lt;/b&gt;&lt;br&gt;&lt;br&gt; Specifies which format is used in the request.&lt;br&gt; Is required for operations with a request body. &lt;ul&gt; &lt;li&gt;Content-type:application/&lt;span style&#x3D;&#39;color:red&#39;&gt;format&lt;/span&gt;&lt;/li&gt; &lt;/ul&gt; In our case,&lt;code&gt;&lt;span style&#x3D;&#39;color:red&#39;&gt;format&lt;/span&gt;&lt;/code&gt;could be replaced with &lt;code&gt;json&lt;/code&gt; or &lt;code&gt;x-www-form-urlencoded&lt;/code&gt; &lt;br&gt;&lt;br&gt;&lt;b&gt;API Responses&lt;/b&gt;&lt;br&gt;&lt;br&gt; HTTP status codes&lt;br&gt; When calling the sevdesk API it is very likely that you will get a HTTP status code in the response.&lt;br&gt; Some API calls will also return JSON response bodies which will contain information about the resource.&lt;br&gt; Each status code which is returned will either be a &lt;b&gt;success&lt;/b&gt; code or an &lt;b&gt;error&lt;/b&gt; code.&lt;br&gt;&lt;br&gt; Success codes &lt;table&gt; &lt;tr&gt; &lt;th&gt;&lt;b&gt;Status code&lt;/b&gt;&lt;/th&gt; &lt;th&gt;&lt;b&gt;Description&lt;/b&gt;&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;200 OK&lt;/code&gt;&lt;/td&gt; &lt;td&gt;The request was successful&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;201 Created&lt;/code&gt;&lt;/td&gt; &lt;td&gt;Most likely to be found in the response of a &lt;b&gt;POST&lt;/b&gt; request.&lt;br&gt; This code indicates that the desired resource was successfully created.&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; &lt;br&gt;Error codes &lt;table&gt; &lt;tr&gt; &lt;th&gt;&lt;b&gt;Status code&lt;/b&gt;&lt;/th&gt; &lt;th&gt;&lt;b&gt;Description&lt;/b&gt;&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;400 Bad request&lt;/code&gt;&lt;/td&gt; &lt;td&gt;The request you sent is most likely syntactically incorrect.&lt;br&gt; You should check if the parameters in the request body or the url are correct.&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;401 Unauthorized&lt;/code&gt;&lt;/td&gt; &lt;td&gt;The authentication failed.&lt;br&gt; Most likely caused by a missing or wrong API token.&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;403 Forbidden&lt;/code&gt;&lt;/td&gt; &lt;td&gt;You do not have the permission the access the resource which is requested.&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;404 Not found&lt;/code&gt;&lt;/td&gt; &lt;td&gt;The resource you specified does not exist.&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;500 Internal server error&lt;/code&gt;&lt;/td&gt; &lt;td&gt;An internal server error has occurred.&lt;br&gt; Normally this means that something went wrong on our side.&lt;br&gt; However, sometimes this error will appear if we missed to catch an error which is normally a 400 status code! &lt;/td&gt; &lt;/tr&gt; &lt;/table&gt; &lt;br&gt;&lt;br&gt; &lt;b&gt;Resource Versioning&lt;/b&gt; &lt;br&gt;&lt;br&gt; We use resource versioning to handle breaking changes for our endpoints, these are rarely used and will be communicated before we remove older versions.&lt;br&gt; To call a different version we use a specific header &lt;code&gt;X-Version&lt;/code&gt; that should be filled with the desired version.&lt;br&gt; &lt;ul&gt;  &lt;li&gt;If you do not specify any version we assume &lt;code&gt;default&lt;/code&gt;&lt;/li&gt; &lt;li&gt;If you specify a version that does not exist or was removed, you will get an error with information which versions are available&lt;/li&gt; &lt;/ul&gt; &lt;table&gt; &lt;tr&gt; &lt;th&gt;X-Version&lt;/th&gt; &lt;th&gt;Description&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;default&lt;/code&gt;&lt;/td&gt; &lt;td&gt;Should always reference the oldest version.&lt;br&gt; If a specific resource is updated with a new version, &lt;br&gt; then the default version stays the same until the old version is deleted&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;&lt;code&gt;1.0&lt;/code&gt; ... &lt;code&gt;1.9&lt;/code&gt;&lt;/td&gt; &lt;td&gt;Our incrementally version for each resource independent&lt;br&gt; &lt;b&gt;Important&lt;/b&gt;: A resource can be available via &lt;code&gt;default&lt;/code&gt; but not &lt;code&gt;1.0&lt;/code&gt;&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;  # Your First Request  After reading the introduction to our API, you should now be able to make your first call.&lt;br&gt; For testing our API, we would always recommend to create a trial account for sevdesk to prevent unwanted changes to your main account.&lt;br&gt; A trial account will be in the highest tariff (materials management), so every sevdesk function can be tested!   To start testing we would recommend one of the following tools: &lt;ul&gt; &lt;li&gt;&lt;a href&#x3D;&#39;https://www.getpostman.com/&#39;&gt;Postman&lt;/a&gt;&lt;/li&gt; &lt;li&gt;&lt;a href&#x3D;&#39;https://curl.haxx.se/download.html&#39;&gt;cURL&lt;/a&gt;&lt;/li&gt; &lt;/ul&gt; This example will illustrate your first request, which is creating a new Contact in sevdesk.&lt;br&gt; &lt;ol&gt; &lt;li&gt;Download &lt;a href&#x3D;&#39;https://www.getpostman.com/&#39;&gt;&lt;b&gt;Postman&lt;/b&gt;&lt;/a&gt; for your desired system and start the application&lt;/li&gt; &lt;li&gt;Enter &lt;span&gt;&lt;b&gt;ht&lt;/span&gt;tps://my.sevdesk.de/api/v1/Contact&lt;/b&gt; as the url&lt;/li&gt; &lt;li&gt;Create an authorization header and insert your API token as the value&lt;/li&gt; &lt;li&gt;For this test, select &lt;b&gt;POST&lt;/b&gt; as the HTTP method&lt;/li&gt; &lt;li&gt;Go to &lt;b&gt;Headers&lt;/b&gt; and enter the key-value pair &lt;b&gt;Content-type&lt;/b&gt; + &lt;b&gt;application/x-www-form-urlencoded&lt;/b&gt;&lt;br&gt; As an alternative, you can just go to &lt;b&gt;Body&lt;/b&gt; and select &lt;b&gt;x-www-form-urlencoded&lt;/b&gt;&lt;/li&gt; &lt;li&gt;Now go to &lt;b&gt;Body&lt;/b&gt; (if you are not there yet) and enter the key-value pairs as shown in the following picture&lt;br&gt;&lt;br&gt; &lt;img src&#x3D;&#39;openAPI/img/FirstRequestPostman.PNG&#39; width&#x3D;&#39;900&#39;&gt;&lt;br&gt;&lt;br&gt;&lt;/li&gt; &lt;li&gt;Click on &lt;b&gt;Send&lt;/b&gt;. Your response should now look like this:&lt;br&gt;&lt;br&gt; &lt;img src&#x3D;&#39;openAPI/img/FirstRequestResponse.PNG&#39; width&#x3D;&#39;900&#39;&gt;&lt;/li&gt; &lt;/ol&gt; As you can see, a successful response in this case returns a JSON-formatted response body containing the contact you just created.&lt;br&gt; For keeping it simple, this was only a minimal example of creating a contact.&lt;br&gt; There are however numerous combinations of parameters that you can provide which add information to your contact.  # sevdesk-Update 2.0  Started in 2024 we introduced a new era of bookkeeping in sevdesk. You can check if you already received the update by clicking on your profile in the top right in the sevdesk WebApp or by using the [Tools/bookkeepingSystemVersion endpoint](#tag/Basics/operation/bookkeepingSystemVersion).&lt;br&gt; The old version will be available for some customers until the end of 2024. In this short list we have outlined the changed endpoints with links to jump to the descriptions. If you received the [api newsletter](https://landing.sevdesk.de/api-newsletter) you already know what changed. Otherwise you can check the api changes [here](https://tech.sevdesk.com/api_news/posts/2024_04_04-system-update-breaking-changes/).  ## Check your bookkeeping system version  With this endpoint you can check which version you / your client uses. On that basis you must use the old or new versions of the endpoints. [Tools/bookkeepingSystemVersion Endpoint](#tag/Basics/operation/bookkeepingSystemVersion)  ## Tax Rules  &lt;I&gt;&lt;b&gt;(affects the properties taxType and taxSet)&lt;/b&gt;&lt;/I&gt;&lt;br&gt; With sevdesk-Update 2.0 we changed the available tax rules. Due to a high likeliness of non-compliant accounting, we won&#39;t support the following tax type with the sevdesk-Update 2.0 anymore:  &#x60;taxType &#x3D; custom (this includes &#39;taxSet&#39;: ... )&#x60;  If you only use &lt;code&gt;taxType &#x3D; default&lt;/code&gt;, &lt;code&gt;taxType &#x3D; eu&lt;/code&gt; and / or &lt;code&gt;taxType &#x3D; ss&lt;/code&gt;, these tax types will automatically be mapped to the new tax rules for a transition period, but you have to make sure the taxRate used in positions is within the allowed ones (you may use the [ReceiptGuidance endpoint](#tag/Voucher/operation/forAllAccounts) for that), otherwise the API will return a validation error (HTTP status code 422). For [orders](#tag/Order), [invoices](#tag/Invoice), [vouchers](#tag/Voucher) and [credit notes](#tag/CreditNote) that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned.&lt;br&gt; So orders, invoices, vouchers and credit notes created within sevdesk system version 1.0 still have a taxType in the response. When they are created in sevdesk-Update 2.0 they will have a taxRule instead.&lt;br&gt; You can continue to use taxType at first, but we recommend switching to taxRule as there are new options available that were not previously supported.&lt;br&gt; For orders, invoices, vouchers and credit notes that were created within sevdesk-Update 2.0 the response will change in all endpoints in which these objects are returned. This documentation holds the most current version of the endpoints.&lt;br&gt; Here are lists of the currently available tax rules, sorted by their use case, structured into revenue/expense and &#39;Regelbesteuerer&#39;/&#39;Kleinunternehmer&#39;.  #### VAT rules for &#39;Regelbesteuerung&#39; in sevdesk-Update 2.0 (Revenue)  &lt;table&gt; &lt;tr&gt; &lt;th&gt;VAT Rule&lt;/th&gt; &lt;th&gt;New Property&lt;/th&gt; &lt;th&gt;Allowed taxRate in positions&lt;/th&gt; &lt;th&gt;Old property (deprecated)&lt;/th&gt; &lt;th&gt;Unsupported use cases&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Umsatzsteuerpflichtige Umsätze&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 1&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;li&gt;7.0&lt;/li&gt; &lt;li&gt;19.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;default&#39;&lt;/code&gt;&lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Ausfuhren&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 2&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Innergemeinschaftliche Lieferungen&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 3&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;li&gt;7.0&lt;/li&gt; &lt;li&gt;19.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;eu&#39;&lt;/code&gt;&lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Steuerfreie Umsätze §4 UStG&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 4&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Reverse Charge gem. §13b UStG&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 5&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Nicht im Inland steuerbare Leistung&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 17&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;noteu&#39;&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;Creation of an advance invoice&lt;/li&gt; &lt;li&gt;Creation of a partial invoice&lt;/li&gt; &lt;li&gt;Creation of a final invoice&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;One Stop Shop (goods)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 18&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;depending on country&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;Usage in vouchers&lt;/li&gt; &lt;li&gt;Creation as e-invoice&lt;/li&gt; &lt;li&gt;Creation of an invoice with a custom revenue account (&lt;code&gt;accountDatev&lt;/code&gt;)&lt;/li&gt; &lt;li&gt;Creation of an advance invoice&lt;/li&gt; &lt;li&gt;Creation of a partial invoice&lt;/li&gt; &lt;li&gt;Creation of a final invoice&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;One Stop Shop (electronic service)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 19&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;depending on country&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;Usage in vouchers&lt;/li&gt; &lt;li&gt;Creation as e-invoice&lt;/li&gt; &lt;li&gt;Creation of an invoice with a custom revenue account (&lt;code&gt;accountDatev&lt;/code&gt;)&lt;/li&gt; &lt;li&gt;Creation of an advance invoice&lt;/li&gt; &lt;li&gt;Creation of a partial invoice&lt;/li&gt; &lt;li&gt;Creation of a final invoice&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;One Stop Shop (other service)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 20&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;depending on country&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;Usage in vouchers&lt;/li&gt; &lt;li&gt;Creation as e-invoice&lt;/li&gt; &lt;li&gt;Creation of an invoice with a custom revenue account (&lt;code&gt;accountDatev&lt;/code&gt;)&lt;/li&gt; &lt;li&gt;Creation of an advance invoice&lt;/li&gt; &lt;li&gt;Creation of a partial invoice&lt;/li&gt; &lt;li&gt;Creation of a final invoice&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;   See the &lt;a href&#x3D;\&quot;#tag/Invoice/operation/createInvoiceFromOrder\&quot;&gt;example request&lt;/a&gt; to create a normal invoice &lt;code&gt;\&quot;invoiceType\&quot;: \&quot;RE\&quot;&lt;/code&gt; from an order that uses a tax rule that does not support advance, partial or final invoices.    #### VAT rules for &#39;Regelbesteuerung&#39; in sevdesk-Update 2.0 (Expense)  &lt;table&gt; &lt;tr&gt; &lt;th&gt;VAT Rule&lt;/th&gt; &lt;th&gt;New Property&lt;/th&gt; &lt;th&gt;Allowed taxRate in positions&lt;/th&gt; &lt;th&gt;Old property (deprecated)&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Innergemeinschaftliche Erwerbe&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 8&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;li&gt;7.0&lt;/li&gt; &lt;li&gt;19.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Vorsteuerabziehbare Aufwendungen&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 9&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;li&gt;7.0&lt;/li&gt; &lt;li&gt;19.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;default&#39;&lt;/code&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Nicht vorsteuerabziehbare Aufwendungen&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 10&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Reverse Charge gem. §13b Abs. 2 UStG mit Vorsteuerabzug 0% (19%)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 12&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 13&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Reverse Charge gem. §13b Abs. 1 EU Umsätze 0% (19%)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 14&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;    #### VAT rules for small business owner (&#39;Kleinunternehmer&#39;) in sevdesk-Update 2.0 (Revenue)  &lt;table&gt; &lt;tr&gt; &lt;th&gt;VAT Rule&lt;/th&gt; &lt;th&gt;New Property&lt;/th&gt; &lt;th&gt;Allowed taxRate in positions&lt;/th&gt; &lt;th&gt;Old property (deprecated)&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Steuer nicht erhoben nach §19UStG&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 11&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;ss&#39;&lt;/code&gt;&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;    #### VAT rules for small business owner (&#39;Kleinunternehmer&#39;) in sevdesk-Update 2.0 (Expense)  &lt;table&gt; &lt;tr&gt; &lt;th&gt;VAT Rule&lt;/th&gt; &lt;th&gt;New Property&lt;/th&gt; &lt;th&gt;Allowed taxRate in positions&lt;/th&gt; &lt;th&gt;Old property (deprecated)&lt;/th&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Nicht vorsteuerabziehbare Aufwendungen&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 10&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxType&#39;: &#39;ss&#39;&lt;/code&gt;&lt;/td&gt; &lt;/tr&gt; &lt;tr&gt; &lt;td&gt;Reverse Charge gem. §13b UStG ohne Vorsteuerabzug 0% (19%)&lt;/td&gt; &lt;td&gt;&lt;code&gt;&#39;taxRule&#39;: 13&lt;/code&gt;&lt;/td&gt; &lt;td&gt; &lt;ul&gt; &lt;li&gt;0.0&lt;/li&gt; &lt;/ul&gt; &lt;/td&gt; &lt;td&gt;-&lt;/td&gt; &lt;/tr&gt; &lt;/table&gt;    ## Booking Accounts  &lt;I&gt;&lt;b&gt;(affects the property accountingType)&lt;/b&gt;&lt;/I&gt;&lt;br&gt; With sevdesk-Update 2.0 we changed the available booking accounts and their combinatorics. If you use accountingTypes with SKR numbers that are still available in our receipt guidance, you do not have to change anything in your requests. These booking accounts will automatically be mapped to the new representation (Account Datev). But you have to make sure the taxRate used in positions and taxRule used in the voucher is within the allowed ones (check the [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)) of the provided booking account, otherwise the API will return a validation error (HTTP status code 422). For orders, invoices, vouchers and credit notes in that were created within sevdesk-Update 2.0 the response will change in all endpoints were these objects are returned.  ## Receipt Guidance  To help you decide which account can be used in conjunction with which tax rules, tax rates and documents, we created several guidance endpoints just there for you to get helpful information. You can find the descriptions in the changes section for Vouchers below or jump directly to the endpoint description by using this link: [Receipt Guidance](#tag/Voucher/operation/forAllAccounts).&lt;br&gt; Receipt Guidance is planned to give you guidance in which account you can pick (depending on your filter criteria and the client settings (e.g. &#39;Kleinunternehmer&#39;)) and which tax rate and [tax rules](#section/sevdesk-Update-2.0/Tax-Rules) are comptaible with them.   ## Vouchers   ### Saving a new voucher ([Voucher/Factory/saveVoucher](#tag/Voucher/operation/voucherFactorySaveVoucher))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Custom vat regulations (taxType &#x3D; custom and provided taxSet)&lt;/li&gt; &lt;li&gt;Only specific tax rates and booking accounts are available. Check [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts)&lt;/li&gt; &lt;li&gt;Custom accounting types do not work anymore&lt;/li&gt; &lt;li&gt;Using an asset booking account without creating an asset is no longer possible&lt;/li&gt; &lt;li&gt;A voucher can not be directly set to paid anymore, therefore only status &lt;code&gt;DRAFT (50)&lt;/code&gt; or &lt;code&gt;UNPAID / DUE (100)&lt;/code&gt; are possible when creating a new voucher. Use the [/api/v1/Voucher/{voucherId}/bookAmount endpoint](#tag/Voucher/operation/bookVoucher) to set a voucher to paid&lt;/li&gt; &lt;li&gt;Setting or changing the property enshrined. Use our new endpoint [/api/v1/Voucher/{voucherId}/enshrine](#tag/Voucher/operation/voucherEnshrine) to enshrine a voucher&lt;/li&gt; &lt;/ol&gt;  ### Get or update an existing voucher ([Voucher/{voucherId}](#tag/Voucher/operation/updateVoucher))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Custom vat regulations (taxType &#x3D; custom and provided taxSet)&lt;/li&gt; &lt;li&gt;See [ReceiptGuidance](#tag/Voucher/operation/forAllAccounts) to check which tax rates are available in conjunction with which tax rules&lt;/li&gt; &lt;/ol&gt;  ### Book a voucher ([Voucher/{voucherId}](#tag/Voucher/operation/bookVoucher))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Voucher with negative voucher positions can not use &#39;cash discount&#39; as a payment difference anymore&lt;/li&gt; &lt;li&gt;A Voucher can only be booked when it was registered beforehand (see above)&lt;/li&gt; &lt;li&gt;Based on the combination of voucher positions some payment difference reasons are not possible anymore&lt;/li&gt; &lt;li&gt;The currency fluctuation (CF) type is no longer supported as a payment difference reason&lt;/li&gt; &lt;/ol&gt;  ## Banking  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Setting or changing the property enshrined will now only be available by using the [appropriate enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)&lt;/li&gt; &lt;/ol&gt;  ## Invoicing  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct invoices are created which than can be further processed in sevdesk. Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Creating an invoice with taxType &lt;code&gt;custom&lt;/code&gt; does not work anymore&lt;/li&gt; &lt;li&gt;Processing an invoice beyond status &lt;code&gt;DRAFT (100)&lt;/code&gt; without a contact does not work anymore&lt;/li&gt; &lt;li&gt;Advanced invoices (&lt;code&gt;invoiceType: &#39;AR&#39;&lt;/code&gt;) and partial invoices (&lt;code&gt;invoiceType: &#39;TR&#39;&lt;/code&gt;) can only be created with the tax rule &#39;Umsatzsteuerpflichtige Umsätze (taxRule: 1)&#39;(for Regelbesteuerer) or &#39;Steuer nicht erhoben nach §19 UStG (taxRule: 11)&#39;(for Kleinunternehmer)&lt;/li&gt; &lt;li&gt;Creating a dunning (&lt;code&gt;invoiceType: &#39;MA&#39;&lt;/code&gt;) with the value of property &lt;code&gt;reminderCharge&lt;/code&gt; greater than 0 does not work anymore&lt;/li&gt; &lt;li&gt;Creating an advanced invoice (&lt;code&gt;invoiceType: &#39;AR&#39;&lt;/code&gt;), a partial invoice (&lt;code&gt;invoiceType: &#39;TR&#39;&lt;/code&gt;) or a final invoice (&lt;code&gt;invoiceType: &#39;ER&#39;&lt;/code&gt;) with a currency deviating from the clients &lt;code&gt;defaultCurrency&lt;/code&gt; is not possible anymore&lt;/li&gt; &lt;li&gt;Changing the status manually does not work anymore (see &#39;Removed endpoint /Invoice/{invoiceId}/changeStatus&#39; below)&lt;/li&gt; &lt;li&gt;Enshrining now has to be done by using the [enshrine endpoint](#tag/Invoice/operation/invoiceEnshrine) (see below)&lt;/li&gt; &lt;/ol&gt;  ### Saving an invoice ([Invoice/Factory/saveInvoice](#tag/Invoice/operation/createInvoiceByFactory))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Invoices can only be created with the status &lt;code&gt;DRAFT (100)&lt;/code&gt; and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)) to automatically change the status accordingly&lt;/li&gt; &lt;li&gt;Setting or changing the property &lt;code&gt;enshrined&lt;/code&gt; is now only possible by using the [enshrine endpoint](#tag/CheckAccountTransaction/operation/checkAccountTransactionEnshrine)&lt;/li&gt; &lt;/ol&gt;  ### Using an order to create an invoice ([Invoice/Factory/createInvoiceFromOrder](#tag/Invoice/operation/createInvoiceFromOrder))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Creating a final invoice (partialType: &#39;ER&#39;) is not possible if an advanced invoice (partialType: &#39;AR&#39;) or partial invoice (partialType: &#39;TR&#39;) exists. This functionality will be added in a later update&lt;/li&gt; &lt;/ol&gt;  ### Removed endpoint /Invoice/{invoiceId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: &lt;ul&gt; &lt;li&gt;[Invoice/{invoiceId}/sendViaEmail](#tag/Invoice/operation/sendInvoiceViaEMail)&lt;/li&gt; &lt;li&gt;[Invoice/{invoiceId}/sendBy](#tag/Invoice/operation/invoiceSendBy)&lt;/li&gt; &lt;li&gt;[Invoice/{invoiceId}/bookAmount](#tag/Invoice/operation/bookInvoice)&lt;/li&gt; &lt;li&gt;[Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)&lt;/li&gt; &lt;li&gt;[Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)&lt;/li&gt; &lt;/ul&gt;  ### New endpoint [Invoice/{invoiceId}/resetToDraft](#tag/Invoice/operation/invoiceResetToDraft)  This new endpoint can be used to reset the status of an invoice to &lt;code&gt;DRAFT (100)&lt;/code&gt;.  ### New endpoint [Invoice/{invoiceId}/resetToOpen](#tag/Invoice/operation/invoiceResetToOpen)  This new endpoint can be used to reset the status of an invoice to &lt;code&gt;OPEN (200)&lt;/code&gt;.  ### New endpoint [Invoice/{invoiceId}/enshrine]((#tag/Invoice/operation/invoiceEnshrine))  The enshrine endpoint is now used to set the property &lt;code&gt;enshrined&lt;/code&gt;. &lt;b&gt;This operation CAN NOT be undone due to legal reasons!&lt;/b&gt;  ## Credit Notes  The changes to the vat rules also apply here. Check the documentation of voucher above as the changes are the same.  ### General stricter validation in PUT and POST endpoints  We added stricter validation to ensure only correct credit notes are created which than can be further processed in sevdesk. Due to the move from taxTypes/taxSets to taxRules you need to check the compatibility of the taxRules in combination with the tax rates. Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Creating a credit note without a date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) for an invoice that has a date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) is no longer possible&lt;/li&gt; &lt;li&gt;Creating a credit note with a date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) for an invoice that has no date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) is no longer possible&lt;/li&gt; &lt;li&gt;Creating a credit note with a date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) that is before the date of delivery (&lt;code&gt;deliveryDateUntil&lt;/code&gt;) of the invoice is no longer possible&lt;/li&gt; &lt;li&gt;Creating a credit note for an advanced invoice (&lt;code&gt;invoiceType: &#39;AR&#39;&lt;/code&gt;) or partial invoice (&lt;code&gt;invoiceType: &#39;TR&#39;&lt;/code&gt;) is no longer possible&lt;/li&gt; &lt;li&gt;Creating a credit note for a voucher is no longer possible&lt;/li&gt; &lt;li&gt;Creating a credit note with a &lt;code&gt;bookingCategory&lt;/code&gt; other than &lt;code&gt;UNDERACHIEVEMENT&lt;/code&gt; is no longer possible&lt;/li&gt; &lt;li&gt;Currency fluctuation (CF) is no longer supported as a payment difference&lt;/li&gt; &lt;/ol&gt;  ### Saving a credit note ([CreditNote/Factory/saveCreditNote](#tag/CreditNote/operation/createcreditNote))  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Credit notes can only be created with the status &lt;code&gt;DRAFT (100)&lt;/code&gt; and can not be changed manually. Use the matching endpoints (e.g. [sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)) to automatically change the status accordingly&lt;/li&gt; &lt;li&gt;Enshrining now has to be done by using the enshrine endpoint (see below)&lt;/li&gt; &lt;/ol&gt;  ### Removed endpoint /CreditNote/Factory/createFromVoucher  The endpoint will be removed. It is not possible anymore to create credit notes for vouchers within sevdesk-Update 2.0. The endpoint continues to stay available for existing sevdesk system version 1.0 clients.  ### Removed endpoint /CreditNote/{creditNoteId}/changeStatus  This endpoint will be completely removed (including sevdesk system version 1.0!). Using these endpoints will automatically change the status accordingly: &lt;ul&gt; &lt;li&gt;[CreditNote/{creditNoteId}/sendViaEmail](#tag/CreditNote/operation/sendCreditNoteViaEMail)&lt;/li&gt; &lt;li&gt;[CreditNote/{creditNoteId}/sendBy](#tag/CreditNote/operation/creditNoteSendBy)&lt;/li&gt; &lt;li&gt;[CreditNote/{creditNoteId}/bookAmount](#tag/CreditNote/operation/bookCreditNote)&lt;/li&gt; &lt;li&gt;[CreditNote/{creditNoteId}/resetToDraft](#tag/CreditNote/operation/creditNoteResetToDraft)&lt;/li&gt; &lt;li&gt;[CreditNote/{creditNoteId}/resetToOpen](#tag/CreditNote/operation/creditNoteResetToOpen)&lt;/li&gt; &lt;/ul&gt;  ### New endpoint CreditNote/{creditNoteId}/resetToDraft  This new endpoint can be used to reset the status of a credit note to &lt;code&gt;DRAFT (100)&lt;/code&gt;. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToDraft).  ### New endpoint CreditNote/{creditNoteId}/resetToOpen  This new endpoint can be used to reset the status of a credit note to &lt;code&gt;OPEN (200)&lt;/code&gt;. You can find the documentation [here](#tag/CreditNote/operation/creditNoteResetToOpen).  ### New endpoint CreditNote/{creditNoteId}/enshrine  [The enshrine endpoint](#tag/CreditNote/operation/creditNoteEnshrine) is now used to set the property &lt;code&gt;enshrined&lt;/code&gt;. &lt;b&gt;This operation CAN NOT be undone due to legal reasons!&lt;/b&gt; ## Parts   ### General stricter validation in PUT and POST endpoints  Following use cases do not work anymore or have changed: &lt;ol&gt; &lt;li&gt;Creating products with a tax rate other than 0.0, 7.0 and 19.0 is no longer possible&lt;/li&gt; &lt;/ol&gt; 
    """,  # noqa: E501
    package_data={"pysevdesk": ["py.typed"]},
)